## bigloo 2.7a-1

=== Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/Makefile                             */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Jan 14 13:40:15 1998                          */
#*    Last change :  Mon Nov 14 14:39:31 2005 (serrano)                */
#*    Copyright   :  1998-2005 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    This Makefile *requires* GNU-Make.                               */
#*    -------------------------------------------------------------    */
#*    The main Bigloo Makefile. Here is a short description of the     */
#*    makefile entries.                                                */
#*                                                                     */
#*    Public entries:                                                  */
#*      boot........... Compile Bigloo on a bare plateform.            */
#*      boot-api....... Compile Bigloo APIs.                           */
#*      compile-bee0...                                                */
#*      compile-bee.... Compile BEE on a bare plateform.               */
#*                      The entry uses auxiliary public points.        */
#*      install........ Install a compiled Bigloo.                     */
#*      install-bee0...                                                */
#*      install-bee.... Install a compiled Bigloo. This uses           */
#*                      install-xxx entry points).                     */
#*      install-api.... Install Bigloo APIs.                           */
#*      uninstall...... Uninstall the bigloo system and Bee.           */
#*      uninstall-bee0.                                                */
#*      uninstall-bee.. Uninstall Bee. This uses uninstall-xxx points. */
#*      unconfigure.... Unconfigure the bigloo system and Bee.         */
#*      test........... Test a compiled Bigloo.                        */
#*      clean.......... Cleaning.                                      */
#*      distclean...... Cleaning.                                      */
#*                                                                     */
#*    Private entries:                                                 */
#*      fullbootstrap.. Bootstrap a development compiler (private)     */
#*      c-fullbootstrap Bootstrap a development compiler (private)     */
#*      bigboot........ Compile Bigloo on already provided plateform.  */
#*                      This is not guarantee to work because it       */
#*                      requires a compatible installed Bigloo         */
#*                      compiler (public)                              */
#*      distrib........ Produces an official bigloo tarball file       */
#*                      (private). The tarball file is built from a    */
#*                      bootstrapped compiler that is freshly checked  */
#*                      out from the revision system. Uses (true-      */
#*                      distrib, bigloo.tar.gz, bigloo.tar).           */
#*      distrib-jvm.... Produces an official bigloo zip file with      */
#*                      default back-end set to jvm (for Windows and   */
#*                      MacIntosh boxes).                              */
#*      zip............ aka for distrib-jvm                            */
#*      rpm............ Produces an rpm file for Bigloo.               */   
#*      newrevision.... Changes the development Bigloo revision.       */
#*      pop............ The population that composes Bigloo.           */
#*      popfilelist.... The sort file list of the Bigloo population.   */
#*      revision....... commit a revision (uses prcs-revision and      */
#*                      cvs-revision).                                 */
#*      checkout....... commit a checkout (uses prcs-checkout and      */
#*                      cvs-checkout).                                 */
#*      checkgmake..... Check that make is gmake.                      */
#*=====================================================================*/
 
#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# the executable used to bootstrap
BIGLOO          = $(BOOTBINDIR)/bigloo
# the shell to be used
SHELL           = /bin/sh
# The directory where to build and install a distribution
DISTRIBTMPDIR	= /tmp
DISTRIBDIR	= $$HOME/prgm/distrib
# The Bigloo html page directory
HTMLPAGEDIR	= $$HOME/public_html/bigloo
# The ftp host and location where to store Bigloo
FTPHOSTNAME	= tahoe
FTPHOST		= $(FTPHOSTNAME).unice.fr
FTPDIR		= $$HOME/public_ftp
# The library to be installed on the ftp server
FTP_LIBRARIES	= contrib/srfi-1.tar.gz \
                  contrib/format.tar.gz \
                  contrib/lib-example.tar.gz
# the libc we are testing for version
LIBC		= /usr/lib/libc.so
# the library C version
LIBCVERSION	= 6
# the rpm architecture (for now only i386 is supported)
RPMARCH		= i686
# the root directory where to remove directory after the rpm contruction
RPMBASEDIR	= /usr/src/RPM
RPMSOURCEDIR	= $(RPMBASEDIR)/SOURCES
RPMBUILDDIR	= $(RPMBASEDIR)/BUILD
# The rpm source directory
RPMSOURCESDIR	= $(RPMBASEDIR)/SOURCES
RPMRPMDIR	= $(RPMBASEDIR)/RPMS
# The JVM standard installation directory
JVMBASEDIR	= "C:\\\\\\\\Bgl`echo $(RELEASE) | sed -e 's/[.]//'`"
# gzip
GZIP		= gzip -9
# zip
ZIP		= zip
# The revision system
REVISIONSYSTEM	= prcs# either prcs or cvs
# The message to log the revision
LOGMSG		= ""
# Sudo command
SUDO		= sudo

BOOTCAPI	= no

#*---------------------------------------------------------------------*/
#*    The directory that compose a version                             */
#*---------------------------------------------------------------------*/
DIRECTORIES	= cigloo \
                  jigloo \
                  bench \
	          autoconf \
                  etc \
                  examples \
                  gc-forward \
                  recette \
                  tools \
                  xlib \
                  runtime \
	          comptime \
		  bdb \
                  bde \
                  bmacs \
                  manuals \
                  doc \
                  win32 \
                  www \
                  api \
                  srfi \
                  bdl \
		  pnet2ms

#*---------------------------------------------------------------------*/
#*    The file that have to be removed when building a distrib.        */
#*---------------------------------------------------------------------*/
NO_DIST_FILES	= .bigloo.prcs_aux \
		  bigloo.lsm \
		  www \
		  comptime/SawJsm \
		  comptime/Jasm \
                  bde/jasm \
                  api/multimedia \
                  api/mail \
                  api/web \
                  api/ssl \
                  api/sqlite

#*---------------------------------------------------------------------*/
#*    boot ...                                                         */
#*    -------------------------------------------------------------    */
#*    Boot a new Bigloo system on a new host. This boot makes use      */
#*    of the pre-compiled C files.                                     */
#*---------------------------------------------------------------------*/
boot: checkgmake
	@ (cd runtime && $(MAKE) boot)
	@ (cd comptime && $(MAKE) boot)
	@ (cd runtime && $(MAKE) heap)
	@ if [ "$(JVMBACKEND)" = "yes" ]; then \
             (PATH=$(BOOTBINDIR):$$PATH; export PATH; \
              cd runtime && \
              $(MAKE) boot-jvm); \
          fi
	@ if [ "$(DOTNETBACKEND)" = "yes" ]; then \
             (PATH=$(BOOTBINDIR):$$PATH; export PATH; \
              cd runtime && \
              $(MAKE) boot-dotnet); \
          fi
	@ (BIGLOOLIB=$(BOOTLIBDIR); \
           export BIGLOOLIB; \
           LD_LIBRARY_PATH=$(BOOTLIBDIR):$$LD_LIBRARY_PATH; \
           export LD_LIBRARY_PATH; \
           PATH=$(BOOTBINDIR):$$PATH; \
           export PATH; \
           (cd bde && $(MAKE) boot) && (cd api && $(MAKE) boot))
	@ echo "Boot Done..."
	@ echo "-------------------------------"

#*---------------------------------------------------------------------*/
#*    manuals                                                          */
#*---------------------------------------------------------------------*/
manuals:
	@ (cd manuals && $(MAKE) html ps)
	@ (cd manuals && $(MAKE) compile-bee)

#*---------------------------------------------------------------------*/
#*    manual-pdf                                                       */
#*---------------------------------------------------------------------*/
manual-pdf:
	@ (cd manuals && $(MAKE) bigloo.pdf)

#*---------------------------------------------------------------------*/
#*    bigboot ...                                                      */
#*    -------------------------------------------------------------    */
#*    Boot a new Bigloo system on a an host. This boot uses an already */
#*    installed Bigloo on that hosts. That is, it recompiles, all the  */
#*    Scheme source files.                                             */
#*    -------------------------------------------------------------    */
#*    To use this entry:                                               */
#*      1- configure the system:                                       */
#*          ./configure --bootconfig                                   */
#*      2- type something like:                                        */
#*          make bigboot BIGLOO=/usr/local/bin/bigloo                  */
#*---------------------------------------------------------------------*/
bigboot: 
	@ mkdir -p bin
	@ mkdir -p lib/$(RELEASE)
	@ (cd runtime && $(MAKE) bigboot BIGLOO=$(BIGLOOBOOT))
	@ (cd comptime && $(MAKE) bigboot BIGLOO=$(BIGLOOBOOT))
	@ (cd comptime && $(MAKE))
	@ (cd runtime && $(MAKE) clean heap libs)
	@ echo "Big boot Done..."
	@ echo "-------------------------------"

#*---------------------------------------------------------------------*/
#*    compile-bee                                                      */
#*    -------------------------------------------------------------    */
#*    Once the system is booted. It is now possible to compile the     */
#*    Bee. This is the role of this entry.                             */
#*    Compile bee on an bootstrapped plateform                         */
#*---------------------------------------------------------------------*/
compile-bee0: 
	@ (LD_LIBRARY_PATH=$(BOOTLIBDIR):$$LD_LIBRARY_PATH && \
           export LD_LIBRARY_PATH && \
           (cd bdl && $(MAKE)) && \
	   (cd cigloo && $(MAKE)) && \
	   if [ "$(JVMBACKEND) " = "yes" ]; then \
              (cd jigloo && $(MAKE)) \
           fi)
	@ if [ "$(EMACSDIR) " != " " ]; then \
            (cd bmacs && $(MAKE) compile-bee) \
          fi

compile-bee1:
	@ (LD_LIBRARY_PATH=$(BOOTLIBDIR):$$LD_LIBRARY_PATH && \
           export LD_LIBRARY_PATH && \
           (cd bdb && $(MAKE)))
	@ (cd runtime && $(MAKE) compile-bee)

compile-bee: compile-bee0
	@ if [ "$(INSTALLBEE)" = "full" ]; then \
            $(MAKE) compile-bee1; \
          fi

#*---------------------------------------------------------------------*/
#*    fullbootstrap ...                                                */
#*    -------------------------------------------------------------    */

=== api/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/api/Makefile                         */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Thu Mar 24 05:30:44 2005                          */
#*    Last change :  Thu Nov 10 13:51:48 2005 (serrano)                */
#*    Copyright   :  2005 Manuel Serrano                               */
#*    -------------------------------------------------------------    */
#*    The API Makefile                                                 */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    DIRECTORIES                                                      */
#*---------------------------------------------------------------------*/
DIRECTORIES= fthread pthread mail ssl web multimedia sqlite

#*---------------------------------------------------------------------*/
#*    Booting on a bare system                                         */
#*---------------------------------------------------------------------*/
boot: boot-c boot-jvm boot-dotnet

fullbootstrap:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
            (cd $$d && $(MAKE) boot) || exit 1; \
	  done

boot-c:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
	    echo "[0m[1;33m$$d:[0m"; \
            (cd $$d && $(MAKE) boot-c) || exit 1; \
          done

boot-jvm:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
            if [ "$(JVMBACKEND)" = "yes" ]; then \
	      echo "[0m[1;33m$$d:[0m"; \
              (cd $$d && $(MAKE) boot-jvm) || exit 1; \
            fi; \
          done

boot-dotnet:
	@ apis="$(APIS)"; \
          for d in $$apis; do \
            if [ "$(DOTNETBACKEND)" = "yes" ]; then \
	      echo "[0m[1;33m$$d:[0m"; \
              (cd $$d && $(MAKE) boot-dotnet) || exit 1; \
            fi \
          done

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean

clean:
	@ for d in $(DIRECTORIES) ; do \
             if [ -d $$d ]; then \
               (cd $$d && $(MAKE) clean); \
             fi \
          done;

cleanall: 
	@ for d in $(DIRECTORIES) ; do \
             if [ -d $$d ]; then \
               (cd $$d && $(MAKE) cleanall); \
             fi \
          done;

distclean: 
	@ for d in $(DIRECTORIES) ; do \
             if [ -d $$d ]; then \
               (cd $$d && $(MAKE) distclean); \
             fi \
          done;

#*---------------------------------------------------------------------*/
#*    install & uninstall                                              */
#*---------------------------------------------------------------------*/
.PHONY: install install-init install-c install-jvm install-dotnet uninstall

install: install-init
	@ $(MAKE) install-c
	@ if [ "$(JVMBACKEND)" = "yes" ]; then \
             $(MAKE) install-jvm; \
          fi
	@ if [ "$(DOTNETBACKEND)" = "yes" ]; then \
             $(MAKE) install-dotnet; \
          fi

install-init:
	@ if [ "$(APIS) " != " " ]; then \
            for d in $(APIS) ; do \
              (cd $$d && $(MAKE) install-init); \
            done \
          fi

install-c:
	@ if [ "$(APIS) " != " " ]; then \
            for d in $(APIS) ; do \
              (cd $$d && $(MAKE) install-c); \
            done \
          fi

install-jvm:
	@ if [ "$(APIS) " != " " ]; then \
            for d in $(APIS) ; do \
              (cd $$d && $(MAKE) install-jvm); \
            done \
          fi

install-dotnet:
	@ if [ "$(APIS) " != " " ]; then \
            for d in $(APIS) ; do \
              (cd $$d && $(MAKE) install-dotnet); \
            done \
          fi

uninstall:
	@ if [ "$(APIS) " != " " ]; then \
            for d in $(APIS) ; do \
              (cd $$d && $(MAKE) uninstall); \
            done \
          fi

#*---------------------------------------------------------------------*/
#*    Populating the APIs                                              */
#*---------------------------------------------------------------------*/
pop: 
	@ for d in $(DIRECTORIES) ; do \
             for f in `cd $$d && $(MAKE) -s pop;`; do \
                echo api/$$f; \
             done; \
          done;
	@ echo api/Makefile

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    Prepare for a distribution                                       */
#*---------------------------------------------------------------------*/
distrib: 
	@ if [ `pwd` = $(BOOTDIR)/api ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi
	@ for d in $(DIRECTORIES); do \
             if [ -d $$d ]; then \
               (cd $$d && $(MAKE) ude); \
             fi; \
          done;
	@ $(RM) -f api/Makefile~

=== autoconf/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/autoconf/Makefile                    */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Thu Jun 19 20:48:50 1997                          */
#*    Last change :  Thu Oct 13 16:03:07 2005 (serrano)                */
#*    Copyright   :  1997-2005 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The global autoconf Makefile.                                    */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Flags                                                            */
#*---------------------------------------------------------------------*/
POPULATION	= Makefile \
                  bigloo_config.h.in configure.java.in configure.cs.in \
                  jsm.scm.in \
                  cnstalign longlong llabs strtoll sigpipe sigsetmask \
                  alignment enforcedcnstalign pipe sigsetmask.ucb \
                  alloca getcwd ptrsize stackdown \
                  ascpp getwd ranlib unix dirname \
                  bcopy indent setjmp setjmp.sparc winreg \
                  bigendian ldshare ldpreload ldsoname sigprocmask \
                  sigchld sigaction \
                  doubleprec xemacspath ldstaticopt ldsharedopt \
                  readline ldextraopt socket info cctest ccoptim \
                  ccprof termio installinfo installinfodir dlopen \
                  user xemacsbin gmaketest ccpic ccpic2 \
                  ziptest javatest jartest \
                  os strip cygwindospath select fcntl ccstrip emacsbrand \
                  emacslisppath thread pthread pthreadlock stacksize gcstd \
                  processor dotnettest sendfile sleep posixfileops timezone \
                  gcflags mmap macosx

#*---------------------------------------------------------------------*/
#*    pop ...                                                          */
#*---------------------------------------------------------------------*/
pop:
	@ echo $(POPULATION:%=autoconf/%)

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean
clean:
	@ find . \( -name '*[~%]'                   \
                       -o -name '.??*[~%]'          \
                       -o -name '#*#'               \
                       -o -name '?*#'               \
                       -o -name \*core \)           \
                     -type f -exec rm {} \;   
	@ echo "cleanup done..."
	@ echo "-------------------------------"

cleanall: clean
distclean: clean

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:
	@ if [ `pwd` = $(BOOTDIR)autoconf ]; then     \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`";   \
             exit 1;                                                 \
          fi
	@ $(MAKE) clean
	@ chmod a+rx $(POPULATION)
	@ /bin/rm -f readline

=== bde/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bde/Makefile                         */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Mon Jun  8 08:36:43 1998                          */
#*    Last change :  Tue Sep  6 10:50:36 2005 (serrano)                */
#*    Copyright   :  1998-2005 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The Makefile for the Bigloo development environment.             */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# Bigloo
BIGLOO		= $(BOOTBINDIR)/bigloo -no-hello
# etags for info
ETAGS		= etags
# etags flags for info scanning
ETFLAGS		= --language=none \
                  --r '/^ - \(essential \|library \|bigloo \)?\(procedure\|syntax\): [^ ]+/' \
                  --r '/^ - bigloo module clause: [^ ]+/' \
                  --r '/^ - bigloo rgc procedure: [^ ]+/' \
                  --r '/^ - bigloo generic: [^ ]+/'
# the shell to be used
SHELL           = /bin/sh

#*---------------------------------------------------------------------*/
#*    Compilation flags                                                */
#*---------------------------------------------------------------------*/
#BFLAGS		= -jvm -jvm-jar -O2 -fsharing -unsafe
BFLAGS		= -O2 -fsharing -unsafe $(SHRD_BDE_OPT)
EFLAGS		=

#*---------------------------------------------------------------------*/
#*    Sources and Objects                                              */
#*---------------------------------------------------------------------*/
#*--- afile -----------------------------------------------------------*/
AFILE_FILE	= afile
AFILE_OBJ	= $(AFILE_FILE:%=afile/%.o)
AFILE_CLASS	= $(AFILE_FILE:%=afile/%.class)

#*--- jfile -----------------------------------------------------------*/
JFILE_FILE	= jfile
JFILE_OBJ	= $(JFILE_FILE:%=jfile/%.o)
JFILE_CLASS	= $(JFILE_FILE:%=jfile/%.class)

#*--- bpp -------------------------------------------------------------*/
BPP_FILE	= bpp reader
BPP_OBJ		= $(BPP_FILE:%=bpp/%.o)

#*--- btags -----------------------------------------------------------*/
BTAGS_FILE	= btags
BTAGS_OBJ	= $(BTAGS_FILE:%=btags/%.o)

#*--- bdepend ---------------------------------------------------------*/
BDEPEND_FILE	= bdepend
BDEPEND_OBJ	= $(BDEPEND_FILE:%=bdepend/%.o)

#*--- bmake -----------------------------------------------------------*/
BMAKE_FILE	= bmake template
BMAKE_OBJ	= $(BMAKE_FILE:%=bmake/%.o)

#*--- bprof -----------------------------------------------------------*/
BPROF_FILE	= bprof
BPROF_OBJ	= $(BPROF_FILE:%=bprof/%.o)

#*--- mco -------------------------------------------------------------*/
MCO_FILE	= mco
MCO_OBJ		= $(MCO_FILE:%=mco/%.o)

#*--- jas -------------------------------------------------------------*/
JAS_LINKFILE	= lib classfile peep opcode wide labels stack produce as \
                  profile
JAS_FILE	= jas 
JAS_AFILE	= jas/.afile
JAS_LINKSRC	= $(JAS_LINKFILE:%=jas/%.scm)
JAS_LINKOBJ	= $(JAS_LINKFILE:%=jas/%.o)
JAS_OBJ		= $(JAS_FILE:%=jas/%.o)

#*--- jasm -------------------------------------------------------------*/
JASM_LINKFILE	= lib classfile opcode peep wide labels cisa stack produce as \
                  dataflow
JASM_FILE	= jasm 
JASM_AFILE	= jasm/.afile
JASM_LINKSRC	= $(JASM_LINKFILE:%=jasm/%.scm)
JASM_LINKOBJ	= $(JASM_LINKFILE:%=jasm/%.o)
JASM_OBJ	= $(JASM_FILE:%=jasm/%.o)

#*---------------------------------------------------------------------*/
#*    Population                                                       */
#*---------------------------------------------------------------------*/
OBJECTS		= $(AFILE_OBJ) $(BPP_OBJ) $(BTAGS_OBJ) $(BDEPEND_OBJ) \
                  $(BMAKE_OBJ) $(BPROF_OBJ) $(MCO_OBJ) $(JFILE_OBJ) \
                  $(JAS_OBJ) $(JASM_OBJ)
SOURCES_FILES	= $(OBJECTS:%.o=%.scm)

POPULATION	= $(SOURCES_FILES) \
	          bmake/makefile.appli \
	          bmake/makefile.library \
                  jas/jas.tex \
                  Makefile

#*---------------------------------------------------------------------*/
#*     Suffixes ...                                                    */
#*---------------------------------------------------------------------*/
.SUFFIXES:
.SUFFIXES: .scm .o .el .elc .class

#*---------------------------------------------------------------------*/
#*    all                                                              */
#*---------------------------------------------------------------------*/
all: $(BOOTBINDIR)/afile \
     $(BOOTBINDIR)/jfile \
     $(BOOTBINDIR)/bdepend \
     $(BOOTBINDIR)/bmake \
     $(BOOTBINDIR)/bpp \
     $(BOOTBINDIR)/btags \
     $(BOOTBINDIR)/bprof \
     $(BOOTBINDIR)/jas \
     $(BOOTBINDIR)/mco \
     dobmem

boot:
	$(MAKE) all BFLAGS="$(BFLAGS) -ld-relative"

dobmem:
	@ if [ "$(LDPRELOADSUPPORT)" = "yes" ]; then \
	    (cd bmem && $(MAKE)) || exit 1; \
	  fi

$(BOOTBINDIR)/afile: $(AFILE_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/afile $(AFILE_OBJ)

afile.class: afile/afile.scm
	(cd afile; \
         $(BIGLOO) -c -jvm $(BFLAGS) $(EFLAGS) afile.scm -o afile.class; \
         mv afile.class ..)

$(BOOTBINDIR)/jfile: $(JFILE_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/jfile $(JFILE_OBJ)

jfile.class: jfile/jfile.scm
	(cd jfile; $(BIGLOO) -c -jvm $(BFLAGS) $(EFLAGS) jfile.scm -o jfile.class; \
         mv jfile.class ..)

$(BOOTBINDIR)/bdepend: $(BDEPEND_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/bdepend $(BDEPEND_OBJ)

$(BOOTBINDIR)/bmake: $(BMAKE_OBJ)
	$(BIGLOO) -no-hello $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/bmake $(BMAKE_OBJ)

$(BOOTBINDIR)/bprof: $(BPROF_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/bprof $(BPROF_OBJ)

$(BOOTBINDIR)/mco: $(MCO_OBJ) ../comptime/Module/checksum.o
	$(BIGLOO) -no-hello $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/mco \
           $(MCO_OBJ) ../comptime/Module/checksum.o

$(BOOTBINDIR)/bpp: $(BPP_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/bpp $(BPP_OBJ)

$(BOOTBINDIR)/btags: $(BTAGS_OBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/btags $(BTAGS_OBJ)

jas: $(BOOTBINDIR)/jas
$(BOOTBINDIR)/jas: $(JAS_LINKSRC) $(JAS_AFILE) $(JAS_OBJ) $(JAS_LINKOBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/jas $(JAS_OBJ) $(JAS_LINKOBJ)

jasm: $(BOOTBINDIR)/jasm
$(BOOTBINDIR)/jasm: $(JASM_LINKSRC) $(JASM_AFILE) $(JASM_OBJ) $(JASM_LINKOBJ)
	$(BIGLOO) $(BFLAGS) $(EFLAGS) -o $(BOOTBINDIR)/jasm $(JASM_OBJ) $(JASM_LINKOBJ)

#*---------------------------------------------------------------------*/
#*    install                                                          */
#*---------------------------------------------------------------------*/
install: all
	if [ $(BINDIR) != $(BOOTBINDIR) ]; then \
	  cp $(BOOTBINDIR)/afile$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/afile$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/afile$(EXE_SUFFIX); \
	  cp $(BOOTBINDIR)/jfile$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/jfile$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/jfile$(EXE_SUFFIX); \
	  cp $(BOOTBINDIR)/bdepend$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/bdepend$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/bdepend$(EXE_SUFFIX); \
	  cp $(BOOTBINDIR)/bmake$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/bmake$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/bmake$(EXE_SUFFIX); \
	  cp $(BOOTBINDIR)/bprof$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/bprof$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/bprof$(EXE_SUFFIX); \
	  cp $(BOOTBINDIR)/mco$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/mco$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/mco$(EXE_SUFFIX); \
	  cp $(BOOTBINDIR)/bpp$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/bpp$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/bpp$(EXE_SUFFIX); \
	  cp $(BOOTBINDIR)/btags$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/btags$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/btags$(EXE_SUFFIX); \
	  cp $(BOOTBINDIR)/jas$(EXE_SUFFIX) $(DESTDIR)$(BINDIR)/jas$(EXE_SUFFIX); \
          chmod $(BMASK) $(DESTDIR)$(BINDIR)/jas$(EXE_SUFFIX); \
          if [ "$(LDPRELOADSUPPORT)" = "yes" ]; then \
	    (cd bmem; $(MAKE) install) || exit 1; \
          fi; \
        fi

#*---------------------------------------------------------------------*/
#*    uninstall                                                        */
#*---------------------------------------------------------------------*/
uninstall:
	- $(RM) -f $(DESTDIR)$(BINDIR)/afile$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/jfile$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bdepend$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bmake$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bprof$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/mco$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/bpp$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/btags$(EXE_SUFFIX)
	- $(RM) -f $(DESTDIR)$(BINDIR)/jas$(EXE_SUFFIX)
	- (cd bmem; $(MAKE) uninstall)

#*---------------------------------------------------------------------*/
#*    touchall                                                         */
#*---------------------------------------------------------------------*/
touchall:
	touch $(SOURCE_FILES)

#*---------------------------------------------------------------------*/
#*     clean ...                                                       */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean

clean:
	@- $(RM) -f $(OBJECTS)
	@- $(RM) -f $(JAS_LINKOBJ)
	@- $(RM) -f $(JASM_LINKOBJ)
	@- $(RM) -f $(JAS_LINKFILE:%=jas/%.c)
	@- $(RM) -f $(JASM_LINKFILE:%=jasm/%.c)
	@- $(RM) -f $(OBJECTS:%.o=%.c)
	@- $(RM) -f .afile
	@- $(RM) -f jas/.afile
	@- $(RM) -f jasm/.afile
	@- $(RM) -f *.class
	@ find . \( -name '*[~%]' \
                       -o -name '.??*[~%]' \
                       -o -name '#*#' \
                       -o -name '?*#' \
                       -o -name \*core \) \
                     -type f -exec rm {} \;   
	@ (cd bmem; $(MAKE) clean)
	@ $(BEEP)
	@ echo "cleanup done..."
	@ echo "-------------------------------"

cleanall: clean
	@- $(RM) -f $(BOOTBINDIR)/afile 
	@- $(RM) -f $(BOOTBINDIR)/jfile 
	@- $(RM) -f $(BOOTBINDIR)/bdepend 
	@- $(RM) -f $(BOOTBINDIR)/bmake 
	@- $(RM) -f $(BOOTBINDIR)/bprof
	@- $(RM) -f $(BOOTBINDIR)/mco
	@- $(RM) -f $(BOOTBINDIR)/bpp 
	@- $(RM) -f $(BOOTBINDIR)/btags
	@- $(RM) -f $(BOOTBINDIR)/jas
	@- $(RM) -f $(BOOTBINDIR)/jasm
	@- $(RM) -f $(JAS_LINKSRC)
	@- $(RM) -f $(JASM_LINKSRC)

distclean: cleanall

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    Prepare Bde for a distribution                                   */
#*---------------------------------------------------------------------*/
distrib:
	@ if [ `pwd` = $(BOOTDIR)/bde ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi

#*---------------------------------------------------------------------*/
#*    jvm                                                              */
#*---------------------------------------------------------------------*/
jvm: afile.class jfile.class

#*---------------------------------------------------------------------*/

=== comptime/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/comptime/Makefile                    */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Jan 14 08:29:03 1998                          */
#*    Last change :  Sun Nov 20 09:20:52 2005 (serrano)                */
#*    Copyright   :  1998-2005 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The Makefile to build the compiler part of Bigloo (bootstrap).   */
#*    This Makefile has to be processed by Gnu make.                   */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Default configuration                                            */
#*---------------------------------------------------------------------*/
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# the executable used to compile (used to bootstrap)
BIGLOO     	= $(BOOTBINDIR)/bigloo
# the produced executable
BIGLOO_DEST	= $(BOOTBINDIR)/bigloo
# the .afile
AFILE           = .afile
# the .jfile
JFILE           = .jfile
# the .etags
ETAGS           = .etags
# the shell to be used
SHELL           = /bin/sh
# another produced executable
NEW_SUFFIX	= new
# another target.
DEFAULT		= plain
# These variables control how we are booting (from Scheme or C)
SCMOBJSUFFIX	= %.o
SCMCLASSSUFFIX	= %.class
DOTNETOBJSUFFIX	= %.obj
COBJSUFFIX	= 
CSRCSUFFIX	= 

#*---------------------------------------------------------------------*/
#*    Bigloo compilation flags                                         */
#*---------------------------------------------------------------------*/
LIBDIRFLAGS	= -lib-dir $(FILDIR)
# Commmon flags
COMMONFLAGS	= -q \
                  -afile $(AFILE) \
                  -fsharing \
                  -fno-reflection \
                  -cc $(CC) \
                  $(LIBDIRFLAGS) \
                  -unsafev \
                  -gno-error-localization \
                  -no-hello
# Optimized _and_ debugged compilation
OGBFLAGS        = $(COMMONFLAGS) -Wall -O2 +rm -g
# Bootstrap flag
BFLAGS		= $(OGBFLAGS)       
EFLAGS		=
# Distribution flag
BDISTFLAGS	= $(COMMONFLAGS) -O2 -rm -unsafe -s
# Distribution Jvm flag
BJVMFLAGS	= $(BDISTFLAGS) -lib-dir $(BOOTLIBDIR)
# Distribution Dotnet flag
BDOTNETFLAGS	= $(BDISTFLAGS) -lib-dir $(BOOTLIBDIR)
# Link flag
LDBOOTFLAGS     = -static-bigloo -ldopt $(CSTRIPFLAGS)
# C compiler flag
CADDFLAGS	= -I$(BOOTLIBDIR)

#*---------------------------------------------------------------------*/
#*    Afile, Jfile and Bdepend tools                                   */
#*---------------------------------------------------------------------*/
AFILE_EXE	= $(BOOTBINDIR)/afile
JFILE_EXE	= $(BOOTBINDIR)/jfile
BTAGS_EXE	= $(BOOTBINDIR)/btags
DEPEND_EXE	= $(BOOTBINDIR)/bdepend

#*---------------------------------------------------------------------*/
#*    License                                                          */
#*---------------------------------------------------------------------*/
LICENSE		= ../LICENSE

#*---------------------------------------------------------------------*/
#*    The compiler source files ...                                    */
#*---------------------------------------------------------------------*/
#*--- init ------------------------------------------------------------*/
INIT_FILE_NOMAIN= parse-args setrc extend
INIT_FILE	= $(INIT_FILE_NOMAIN) main

INIT_OBJ_NOMAIN	= $(INIT_FILE_NOMAIN:%=Init/%.o)
INIT_OBJ	= $(INIT_FILE:%=Init/%.o)

#*--- tools -----------------------------------------------------------*/
TOOLS_FILE	= args location progn trace speek error shape misc date \
                  dsssl license

TOOLS_OBJ	= $(TOOLS_FILE:%=Tools/%.o)

#*--- engine ----------------------------------------------------------*/
ENGINE_FILE	= compiler engine param interp link signals pass \
                  configure

ENGINE_OBJ	= $(ENGINE_FILE:%=Engine/%.o)

#*--- heap ------------------------------------------------------------*/
HEAP_FILE	= restore make

HEAP_OBJ	= $(HEAP_FILE:%=Heap/%.o)

#*--- write -----------------------------------------------------------*/
WRITE_FILE	= version expanded scheme ast

WRITE_OBJ	= $(WRITE_FILE:%=Write/%.o)

#*--- read ------------------------------------------------------------*/
READ_FILE	= access include src inline load reader jvm

READ_OBJ	= $(READ_FILE:%=Read/%.o)

#*--- module ----------------------------------------------------------*/
MODULE_FILE	= foreign impuse main prototype with class include \
                  module statexp eval load pragma type library checksum \
                  option alibrary java

MODULE_OBJ	= $(MODULE_FILE:%=Module/%.o)

#*--- ast -------------------------------------------------------------*/
AST_FILE	= build venv glo-decl node unit dump glo-def pragma \
                  var find-gdefs ident remove local sexp labels let \
                  exit substitute alphatize occur app apply lvtype \
                  hrtype shrinkify check-init private check-sharing init \

AST_OBJ		= $(AST_FILE:%=Ast/%.o)

#*--- beta ------------------------------------------------------------*/
BETA_FILE	= walk

BETA_OBJ	= $(BETA_FILE:%=Beta/%.o)

#*--- cc --------------------------------------------------------------*/
CC_FILE		= exec indent cc ld

CC_OBJ		= $(CC_FILE:%=Cc/%.o)

#*--- foreign ---------------------------------------------------------*/
FOREIGN_FILE	= access cenum cptr ctype calias cfun cstruct copaque \
                  library jtype
 
FOREIGN_OBJ	= $(FOREIGN_FILE:%=Foreign/%.o)

#*--- Type ------------------------------------------------------------*/
TYPE_FILE	= cache tenv type coercion tools typeof pptype misc

TYPE_OBJ	= $(TYPE_FILE:%=Type/%.o)

#*--- expand ----------------------------------------------------------*/
EXPAND_FILE	= eps assert case define expander garith iarith farith \
                  if initial lambda let map struct exit object \
                  srfi-0 mvalue

EXPAND_OBJ	= $(EXPAND_FILE:%=Expand/%.o)

#*--- inline ----------------------------------------------------------*/
INLINE_FILE	= walk inline app size simple recursion variant loop


INLINE_OBJ	= $(INLINE_FILE:%=Inline/%.o)

#*--- coerce ----------------------------------------------------------*/
COERCE_FILE	= walk pproto coerce app funcall apply convert

COERCE_OBJ	= $(COERCE_FILE:%=Coerce/%.o)

#*--- globalize -------------------------------------------------------*/
GLOBALIZE_FILE	= walk ginfo escape gn node free kapture integration \
                  new-body loc2glo gloclo clocto globalize

GLOBALIZE_OBJ	= $(GLOBALIZE_FILE:%=Globalize/%.o)

#*--- cnst ------------------------------------------------------------*/
CNST_FILE	= walk cache alloc node initialize

CNST_OBJ	= $(CNST_FILE:%=Cnst/%.o)

#*--- cfa -------------------------------------------------------------*/
CFA_FILE	= app cinfo iterate set approx collect loose show walk \
                  setup vector cfa funcall procedure struct type \
                  closure tvector box specialize cinfo2 cinfo3 \
                  arithmetic ltype

CFA_OBJ		= $(CFA_FILE:%=Cfa/%.o)

#*--- Integrate -------------------------------------------------------*/
INTEGRATE_FILE	= walk definition iinfo a kk u g ctn cto kaptured \
                  let-fun loc2glo node free

INTEGRATE_OBJ	= $(INTEGRATE_FILE:%=Integrate/%.o)

#*--- Tailc -------------------------------------------------------*/
TAILC_FILE	= walk

TAILC_OBJ	= $(TAILC_FILE:%=Tailc/%.o)

#*--- Cgen ------------------------------------------------------------*/
CGEN_FILE	= compile cop emit-cop cgen capp

CGEN_OBJ	= $(CGEN_FILE:%=Cgen/%.o)

#*--- Jas ------------------------------------------------------------*/
JAS_FILE        = lib classfile opcode peep wide labels stack profile produce as

JAS_OBJ		= $(JAS_FILE:%=Jas/%.o)

#*--- Jasm -----------------------------------------------------------*/
JASM_FILE       = cisa lib classfile opcode peep wide labels stack produce \
                  dataflow as

JASM_OBJ	= $(JASM_FILE:%=Jasm/%.o)

#*--- Jvm ------------------------------------------------------------*/
JVM_FILE	= extern env instr inline peephole lisp prelude compress \
                  init constr closure \
                  compiler tail effect predicate expr \
                  compile jdump jld vmemq

JVM_OBJ		= $(JVM_FILE:%=Jvm/%.o)

#*--- BackEnd ---------------------------------------------------------*/
BACKEND_FILE    = backend walk init lib cplib cvm bvm \
                  c c-main c-proto c-emit  \
                  jvm jvm-class \
                  dotnet dotnet-class \
                  jsm jsm-class
   

BACKEND_OBJ	= $(BACKEND_FILE:%=BackEnd/%.o)

#*--- SawMill ---------------------------------------------------------*/
SAW_FILE        = lib defs rtl node2rtl collapse remove InlineReturn \
		  blockorder gotos cast expr woodcutter \
		  procedures elsewhere regalloc regset

SAW_OBJ		= $(SAW_FILE:%=SawMill/%.o)

#*--- SawC ------------------------------------------------------------*/
SAW_C_FILE      = compile code

SAW_C_OBJ	= $(SAW_C_FILE:%=SawC/%.o)

#*--- SawMsil ---------------------------------------------------------*/
SAW_MSIL_FILE	= compile type code inline maxstack funcall names out dnld

SAW_MSIL_OBJ	= $(SAW_MSIL_FILE:%=SawMsil/%.o)

#*--- SawJvm -----------------------------------------------------------*/
SAW_JVM_FILE	= compile type code inline funcall names out jld

SAW_JVM_OBJ	= $(SAW_JVM_FILE:%=SawJvm/%.o)

#*--- SawJsm -----------------------------------------------------------*/
SAW_JSM_FILE	= compile type code inline funcall names out jld hardware

SAW_JSM_OBJ	= $(SAW_JSM_FILE:%=SawJsm/%.o)

#*--- Hgen ------------------------------------------------------------*/
HGEN_FILE	= walk

HGEN_OBJ	= $(HGEN_FILE:%=Hgen/%.o)

#*--- tvector ---------------------------------------------------------*/
TVECTOR_FILE	= tvector access cnst

TVECTOR_OBJ	= $(TVECTOR_FILE:%=Tvector/%.o)

#*--- trace -----------------------------------------------------------*/
TRACE_FILE	= walk

TRACE_OBJ	= $(TRACE_FILE:%=Trace/%.o)

#*--- fail ------------------------------------------------------------*/
FAIL_FILE	= walk

FAIL_OBJ	= $(FAIL_FILE:%=Fail/%.o)

#*--- callcc ----------------------------------------------------------*/
CALLCC_FILE	= walk

CALLCC_OBJ	= $(CALLCC_FILE:%=Callcc/%.o)

#*--- reduce ----------------------------------------------------------*/
REDUCE_FILE	= walk cond typec ftypec copy cse same 1occ sbeta

REDUCE_OBJ	= $(REDUCE_FILE:%=Reduce/%.o)

#*--- effect ----------------------------------------------------------*/
EFFECT_FILE	= effect walk cgraph spread feffect

EFFECT_OBJ	= $(EFFECT_FILE:%=Effect/%.o)

#*--- object ----------------------------------------------------------*/
OBJECT_FILE	= class generic method getter \
                  plain-access wide-access java-access \
                  struct slots tools coercion predicate creator nil

OBJECT_OBJ	= $(OBJECT_FILE:%=Object/%.o)

#*--- bdb -------------------------------------------------------------*/
BDB_FILE	= setting spread-obj initialize walk emit

BDB_OBJ		= $(BDB_FILE:%=Bdb/%.o)

#*--- prof -------------------------------------------------------------*/
PROF_FILE	= unit emit

PROF_OBJ	= $(PROF_FILE:%=Prof/%.o)

#*--- user ------------------------------------------------------------*/
USER_FILE	= user

USER_OBJ	= $(USER_FILE:%=User/%.o)

#*---------------------------------------------------------------------*/
#*    The object files                                                 */

=== gc-boehm/Makefile ===
#*---------------------------------------------------------------------*/
#*    Bigloo start                                                     */
#*---------------------------------------------------------------------*/
include ../Makefile.config
include ../Makefile.misc
#*---------------------------------------------------------------------*/
#*    Bigloo stop                                                      */
#*---------------------------------------------------------------------*/

# This is the original manually generated Makefile.  It may still be used
# to build the collector.
#
# Primary targets:
# gc.a - builds basic library
# c++ - adds C++ interface to library
# cords - adds cords (heavyweight strings) to library
# test - prints porting information, then builds basic version of gc.a,
#      	 and runs some tests of collector and cords.  Does not add cords or
#	 c++ interface to gc.a
# cord/de - builds dumb editor based on cords.
ABI_FLAG= 
# ABI_FLAG should be the cc flag that specifies the ABI.  On most
# platforms this will be the empty string.  Possible values:
# +DD64 for 64-bit executable on HP/UX.
# -n32, -n64, -o32 for SGI/MIPS ABIs.

AS_ABI_FLAG=$(ABI_FLAG)
# ABI flag for assembler.  On HP/UX this is +A64 for 64 bit
# executables.

#*---------------------------------------------------------------------*/
#*    Bigloo start                                                     */
#*---------------------------------------------------------------------*/
#* CC=cc $(ABI_FLAG)                                                   */
#*---------------------------------------------------------------------*/
#*    Bigloo stop                                                      */
#*---------------------------------------------------------------------*/
CXX=g++ $(ABI_FLAG)
AS=as $(AS_ABI_FLAG)
#  The above doesn't work with gas, which doesn't run cpp.
#  Define AS as `gcc -c -x assembler-with-cpp' instead.

# Redefining srcdir allows object code for the nonPCR version of the collector
# to be generated in different directories.
srcdir= .
VPATH= $(srcdir)

CFLAGS= -O -I$(srcdir)/include -DATOMIC_UNCOLLECTABLE -DNO_SIGNALS -DNO_EXECUTE_PERMISSION -DSILENT -DALL_INTERIOR_POINTERS

# To build the parallel collector on Linux, add to the above:
# -DGC_LINUX_THREADS -DPARALLEL_MARK -DTHREAD_LOCAL_ALLOC
# To build the parallel collector in a static library on HP/UX,
# add to the above:
# -DGC_HPUX_THREADS -DPARALLEL_MARK -DTHREAD_LOCAL_ALLOC -D_POSIX_C_SOURCE=199506L -mt
# To build the thread-safe collector on Tru64, add to the above:
# -pthread -DGC_OSF1_THREADS

# HOSTCC and HOSTCFLAGS are used to build executables that will be run as
# part of the build process, i.e. on the build machine.  These will usually
# be the same as CC and CFLAGS, except in a cross-compilation environment.
# Note that HOSTCFLAGS should include any -D flags that affect thread support.
HOSTCC=$(CC)
HOSTCFLAGS=$(CFLAGS)

# For dynamic library builds, it may be necessary to add flags to generate
# PIC code, e.g. -fPIC on Linux.

# Setjmp_test may yield overly optimistic results when compiled
# without optimization.

# These define arguments influence the collector configuration:
# -DSILENT disables statistics printing, and improves performance.
# -DFIND_LEAK causes GC_find_leak to be initially set.
#   This causes the collector to assume that all inaccessible
#   objects should have been explicitly deallocated, and reports exceptions.
#   Finalization and the test program are not usable in this mode.
# -DGC_SOLARIS_THREADS enables support for Solaris (thr_) threads.
#   (Clients should also define GC_SOLARIS_THREADS and then include
#   gc.h before performing thr_ or dl* or GC_ operations.)
#   Must also define -D_REENTRANT.
# -DGC_SOLARIS_PTHREADS enables support for Solaris pthreads.
#   (Internally this define GC_SOLARIS_THREADS as well.)
# -DGC_IRIX_THREADS enables support for Irix pthreads.  See README.irix.
# -DGC_HPUX_THREADS enables support for HP/UX 11 pthreads.
#   Also requires -D_REENTRANT or -D_POSIX_C_SOURCE=199506L. See README.hp.
# -DGC_LINUX_THREADS enables support for Xavier Leroy's Linux threads.
#   see README.linux.  -D_REENTRANT may also be required.
# -DGC_OSF1_THREADS enables support for Tru64 pthreads.
# -DGC_FREEBSD_THREADS enables support for FreeBSD pthreads.
#   Appeared to run into some underlying thread problems.
# -DGC_DARWIN_THREADS enables support for Mac OS X pthreads.
# -DGC_AIX_THREADS enables support for IBM AIX threads.
# -DGC_DGUX386_THREADS enables support for DB/UX on I386 threads.
#   See README.DGUX386.
# -DGC_WIN32_THREADS enables support for win32 threads.  That makes sense
#   for this Makefile only under Cygwin.
# -DGC_THREADS should set the appropriate one of the above macros.
#   It assumes pthreads for Solaris.
# -DALL_INTERIOR_POINTERS allows all pointers to the interior
#   of objects to be recognized.  (See gc_priv.h for consequences.)
#   Alternatively, GC_all_interior_pointers can be set at process
#   initialization time.
# -DSMALL_CONFIG tries to tune the collector for small heap sizes,
#   usually causing it to use less space in such situations.
#   Incremental collection no longer works in this case.
# -DLARGE_CONFIG tunes the collector for unusually large heaps.
#   Necessary for heaps larger than about 500 MB on most machines.
#   Recommended for heaps larger than about 64 MB.
# -DDONT_ADD_BYTE_AT_END is meaningful only with -DALL_INTERIOR_POINTERS or
#   GC_all_interior_pointers = 1.  Normally -DALL_INTERIOR_POINTERS
#   causes all objects to be padded so that pointers just past the end of
#   an object can be recognized.  This can be expensive.  (The padding
#   is normally more than one byte due to alignment constraints.)
#   -DDONT_ADD_BYTE_AT_END disables the padding.
# -DNO_SIGNALS does not disable signals during critical parts of
#   the GC process.  This is no less correct than many malloc 
#   implementations, and it sometimes has a significant performance
#   impact.  However, it is dangerous for many not-quite-ANSI C
#   programs that call things like printf in asynchronous signal handlers.
#   This is on by default.  Turning it off has not been extensively tested with
#   compilers that reorder stores.  It should have been.
# -DNO_EXECUTE_PERMISSION may cause some or all of the heap to not
#   have execute permission, i.e. it may be impossible to execute
#   code from the heap.  Currently this only affects the incremental
#   collector on UNIX machines.  It may greatly improve its performance,
#   since this may avoid some expensive cache synchronization.
# -DGC_NO_OPERATOR_NEW_ARRAY declares that the C++ compiler does not support
#   the  new syntax "operator new[]" for allocating and deleting arrays.
#   See gc_cpp.h for details.  No effect on the C part of the collector.
#   This is defined implicitly in a few environments.  Must also be defined
#   by clients that use gc_cpp.h.
# -DREDIRECT_MALLOC=X causes malloc to be defined as alias for X.
#   Unless the following macros are defined, realloc is also redirected
#   to GC_realloc, and free is redirected to GC_free.
#   Calloc and strdup are redefined in terms of the new malloc.  X should
#   be either GC_malloc or GC_malloc_uncollectable, or
#   GC_debug_malloc_replacement.  (The latter invokes GC_debug_malloc
#   with dummy source location information, but still results in
#   properly remembered call stacks on Linux/X86 and Solaris/SPARC.
#   It requires that the following two macros also be used.)
#   The former is occasionally useful for working around leaks in code
#   you don't want to (or can't) look at.  It may not work for
#   existing code, but it often does.  Neither works on all platforms,
#   since some ports use malloc or calloc to obtain system memory.
#   (Probably works for UNIX, and win32.)  If you build with DBG_HDRS_ALL,
#   you should only use GC_debug_malloc_replacement as a malloc
#   replacement.
# -DREDIRECT_REALLOC=X causes GC_realloc to be redirected to X.
#   The canonical use is -DREDIRECT_REALLOC=GC_debug_realloc_replacement,
#   together with -DREDIRECT_MALLOC=GC_debug_malloc_replacement to
#   generate leak reports with call stacks for both malloc and realloc.
#   This also requires the following:
# -DREDIRECT_FREE=X causes free to be redirected to X.  The
#   canonical use is -DREDIRECT_FREE=GC_debug_free.
# -DIGNORE_FREE turns calls to free into a noop.  Only useful with
#   -DREDIRECT_MALLOC.
# -DNO_DEBUGGING removes GC_dump and the debugging routines it calls.
#   Reduces code size slightly at the expense of debuggability.
# -DJAVA_FINALIZATION makes it somewhat safer to finalize objects out of
#   order by specifying a nonstandard finalization mark procedure  (see
#   finalize.c).  Objects reachable from finalizable objects will be marked
#   in a sepearte postpass, and hence their memory won't be reclaimed.
#   Not recommended unless you are implementing a language that specifies
#   these semantics.  Since 5.0, determines only only the initial value
#   of GC_java_finalization variable.
# -DFINALIZE_ON_DEMAND causes finalizers to be run only in response
#   to explicit GC_invoke_finalizers() calls.
#   In 5.0 this became runtime adjustable, and this only determines the
#   initial value of GC_finalize_on_demand.
# -DATOMIC_UNCOLLECTABLE includes code for GC_malloc_atomic_uncollectable.
#   This is useful if either the vendor malloc implementation is poor,
#   or if REDIRECT_MALLOC is used.
# -DHBLKSIZE=ddd, where ddd is a power of 2 between 512 and 16384, explicitly
#   sets the heap block size.  Each heap block is devoted to a single size and
#   kind of object.  For the incremental collector it makes sense to match
#   the most likely page size.  Otherwise large values result in more
#   fragmentation, but generally better performance for large heaps.
# -DUSE_MMAP use MMAP instead of sbrk to get new memory.
#   Works for Solaris and Irix.
# -DUSE_MUNMAP causes memory to be returned to the OS under the right
#   circumstances.  This currently disables VM-based incremental collection.
#   This is currently experimental, and works only under some Unix,
#   Linux and Windows versions.
# -DMMAP_STACKS (for Solaris threads) Use mmap from /dev/zero rather than
#   GC_scratch_alloc() to get stack memory.
# -DPRINT_BLACK_LIST Whenever a black list entry is added, i.e. whenever
#   the garbage collector detects a value that looks almost, but not quite,
#   like a pointer, print both the address containing the value, and the
#   value of the near-bogus-pointer.  Can be used to identifiy regions of
#   memory that are likely to contribute misidentified pointers.
# -DKEEP_BACK_PTRS Add code to save back pointers in debugging headers
#   for objects allocated with the debugging allocator.  If all objects
#   through GC_MALLOC with GC_DEBUG defined, this allows the client
#   to determine how particular or randomly chosen objects are reachable
#   for debugging/profiling purposes.  The gc_backptr.h interface is
#   implemented only if this is defined.
# -DGC_ASSERTIONS Enable some internal GC assertion checking.  Currently
#   this facility is only used in a few places.  It is intended primarily
#   for debugging of the garbage collector itself, but could also
# -DDBG_HDRS_ALL Make sure that all objects have debug headers.  Increases
#   the reliability (from 99.9999% to 100% mod. bugs) of some of the debugging
#   code (especially KEEP_BACK_PTRS).  Makes -DSHORT_DBG_HDRS possible.
#   Assumes that all client allocation is done through debugging
#   allocators.
# -DSHORT_DBG_HDRS Assume that all objects have debug headers.  Shorten
#   the headers to minimize object size, at the expense of checking for
#   writes past the end of an object.  This is intended for environments
#   in which most client code is written in a "safe" language, such as
#   Scheme or Java.  Assumes that all client allocation is done using

=== recette/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/recette/Makefile                     */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Mon Nov  2 17:38:43 1992                          */
#*    Last change :  Thu Oct  6 10:11:45 2005 (serrano)                */
#*    Copyright   :  1992-2005 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The Makefile to build the recette                                */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Default configuration                                            */
#*---------------------------------------------------------------------*/
include ../Makefile.config

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# the executable used to bootstrap
BIGLOO          = $(BOOTBINDIR)/bigloo
# which C compiler to be used
CC              = `$(BIGLOO) -eval '(begin (print *cc*) (exit 0))'`
# the shell to be used
SHELL           = /bin/sh
# lint
LINT		= lint
# lint options
LINTFLAGS	= -u -v -I$(BOOTLIBDIR)
# The package to compute afile
AFILE		= $(BOOTBINDIR)/afile
# The package association tool
JFILE		= $(BOOTBINDIR)/jfile
# The tags producer
BTAGS		= $(BOOTBINDIR)/btags
#
JVMCLASSPATH	= -jvm-bigloo-classpath $(BOOTLIBDIR)

#*---------------------------------------------------------------------*/
#*  !!! WARNING !!! WARNING !!! WARNING !!! WARNING !!!  WARNING !!!   */
#*    -------------------------------------------------------------    */
#*  The recette can't be compiled in `-unsafe' mode (due to try forms) */
#*---------------------------------------------------------------------*/
VERBOSE		= 
EFLAGS		= 
BFLAGS          = $(VERBOSE) -cg -g -O3 -q -Wall -init-lib \
                  -eval "(set! *indent* (= 1 2))"

BCFLAGS         = $(BFLAGS) -afile .afile-c
                  

BJVMFLAGS       = $(BFLAGS) -afile .afile-jvm -jfile .jfile-jvm -g
BPURIFYJVMFLAGS	=

BDNETFLAGS	= $(BFLAGS) -afile .afile-dotnet -jfile .jfile-dotnet -g -dotnet-managed -init-read -dotnet-mono-workaround -dotnet-pnet-workaround -saw

#*---------------------------------------------------------------------*/
#*    Les objects destinations                                         */
#*---------------------------------------------------------------------*/
ICOMMON		= vital bps bool list vector struct print \
                  string kwote case bexit vararity apply \
                  globalis filtre rgc-trap rgc-jm port \
                  read tail sqic eval inline match letrec macro \
                  flonum number bchar define error cse \
                  kapture include 0cfa alias alias-aux main \
                  rgc-eval rgc hash module import1 import2 \
                  cfa2 cell hygien wind dsssl sua peek callcc fringe \
                  unicode optim pregexp lalr system date process \
                  mmap

OCOMMON		= object object1 object2 object3 object4

COMMON		= $(ICOMMON) $(OCOMMON)

C_SPECIFIC	= external-c big-file
C_OBJECTS	= $(COMMON:%=%.$(C_OBJ_EXTENSION)) $(C_SPECIFIC:%=%.$(C_OBJ_EXTENSION))
OBJECT_C_FOREIGN= c-file.$(C_OBJ_EXTENSION)

JVM_SPECIFIC	= external
JVM_OBJECTS	= $(COMMON:%=%.class) $(JVM_SPECIFIC:%=%.class)
OBJECT_JVM_FORE	= Point.class ArrayTest.class Intf.class

DOTNET_SPECIFIC = external
DOTNET_OBJECTS  = $(COMMON:%=%.obj) $(DOTNET_SPECIFIC:%=%.obj)
OBJECT_DOTNET_CS= ArrayTest.cs foo.cs Intf.cs Point.cs
OBJECT_DOTNET_IL= objs_dotnet/patch.obj

OBJECT_DOTNET_FORE= $(OBJECT_DOTNET_CS) $(OBJECT_DOTNET_IL) 
IL_OBJECTS	= $(OBJECT_DOTNET_CS:%.cs=%.il) \
                  $(DOTNET_OBJECTS:%.obj=%.il)

LN_OBJECTS	= $(C_OBJECTS:%.$(C_OBJ_EXTENSION)=%.ln)

C_TMPS		= $(C_OBJECTS:%.$(C_OBJ_EXTENSION)=%.c)

SOURCE_FILES	= $(COMMON:%=%.scm) \
                  $(C_SPECIFIC:%=%.scm) \
                  $(JVM_SPECIFIC:%=%.scm) \
                  $(OBJECT_JVM_FORE:%.class=%.java) \
                  $(OBJECT_DOTNET_CS:%.obj=%.cs) \
                  $(OBJECT_DOTNET_IL:objs_dotnet/%.obj=%.il) \
                  c-file.c

POPULATION	= $(SOURCE_FILES) \
                  Makefile \
                  test.sch \
                  c-file.h \
		  include.sch \
		  include2.sch \
		  misc

#*---------------------------------------------------------------------*/
#*     Les suffixes ...                                                */
#*---------------------------------------------------------------------*/
.SUFFIXES:
.SUFFIXES: .$(C_OBJ_EXTENSION) .scm .c .class .java .ln .il .obj

#*---------------------------------------------------------------------*/
#*    recette                                                          */
#*---------------------------------------------------------------------*/
recette: .etags .afile-c objs_c $(C_OBJECTS:%=objs_c/%) $(OBJECT_C_FOREIGN:%=objs_c/%)
	$(BIGLOO) $(BCFLAGS) $(EFLAGS) -o recette $(C_OBJECTS:%=objs_c/%) $(OBJECT_C_FOREIGN:%=objs_c/%)
	@ echo "Recette (C) Done..."
	@ echo "-------------------------------"

new: 
	$(MAKE) BIGLOO=bigloo.new

static-recette: .afile-c objs_c $(C_OBJECTS:%=objs_c/%) $(OBJECT_C_FOREIGN:%=objs_c/%)
	$(BIGLOO) $(BCFLAGS) $(EFLAGS) -o recette.static $(C_OBJECTS:%=objs_c/%) $(OBJECT_C_FOREIGN:%=objs_c/%) -static-bigloo
	@ echo "Static Recette Done..."
	@ echo "-------------------------------"

jvm: recette-jvm
jvm-nojar: recette-jvm
recette-jvm: .jfile-jvm .afile-jvm objs_jvm $(JVM_OBJECTS:%=objs_jvm/%) $(OBJECT_JVM_FORE:%=objs_jvm/%)
	$(BIGLOO) -jvm -jvm-directory objs_jvm -jvm-classpath "objs_jvm" -no-jvm-jar $(BCFLAGS) $(EFLAGS) $(JVMCLASSPATH) -o $@$(SCRIPTEXTENSION) $(JVM_OBJECTS:%=objs_jvm/%) $(OBJECT_JVM_FORE:%=objs_jvm/%)
	@ echo "Recette (JVM) Done..."
	@ echo "-------------------------------"

jvm-jar: recette-jvm-jar
recette-jvm-jar: .jfile-jvm .afile-jvm objs_jvm $(JVM_OBJECTS:%=objs_jvm/%) $(OBJECT_JVM_FORE:%=objs_jvm/%)
	$(BIGLOO) -jvm -jvm-directory objs_jvm -jvm-classpath "objs_jvm" -jvm-jar $(BCFLAGS) $(EFLAGS) $(JVMCLASSPATH) -o $@$(SCRIPTEXTENSION) $(OBJECT_JVM_FORE:%=objs_jvm/%) $(JVM_OBJECTS:%=objs_jvm/%)
	@ echo "Recette (JVM jar) Done..."
	@ echo "-------------------------------"

djvm: recette-jvm-debug
recette-jvm-debug: .jfile-dotnet .afile-dotnet objs_jvm $(JVM_OBJECTS:%=objs_jvm/%) $(OBJECT_JVM_FORE:%=objs_jvm/%)
	$(BIGLOO) -jvm $(BCFLAGS) $(EFLAGS) $(JVMCLASSPATH) -o $@$(SCRIPTEXTENSION) $(JVM_OBJECTS:%=objs_jvm/%) $(OBJECT_JVM_FORE:%=objs_jvm/%)
	@ echo "Recette (JVM debug) Done..."
	@ echo "-------------------------------"

jvm-purify:
	$(MAKE) jvm BPURIFYJVMFLAGS=-jvm-purify

.net: dotnet
dotnet: recette-dotnet

recette-dotnet: .jfile-dotnet .afile-dotnet objs_dotnet $(DOTNET_OBJECTS:%=objs_dotnet/%) $(OBJECT_DOTNET_FORE)
	$(BIGLOO) $(EFLAGS) -dotnet -dotnet-ld-style $(DOTNETLDSTYLE) -o $@$(SCRIPTEXTENSION) $(DOTNET_OBJECTS:%=objs_dotnet/%) $(OBJECT_DOTNET_FORE)
	@ echo "Recette (DotNet) Done..."
	@ echo "-------------------------------"

#*---------------------------------------------------------------------*/
#*    bee                                                              */
#*---------------------------------------------------------------------*/
getbinary:
	echo "recette"

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*    -------------------------------------------------------------    */
#*    We prepare the compiler for a distribution                       */
#*---------------------------------------------------------------------*/
distrib: 
	@ if [ `pwd` = $(BOODIR)/recette ]; then \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`"; \
             exit 1; \
          fi
	@ $(MAKE) cleanall
	@ $(MAKE) .jfile-jvm
	@ $(MAKE) .jfile-dotnet

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*---------------------------------------------------------------------*/
pop:
	@ echo $(POPULATION:%=recette/%)

#*---------------------------------------------------------------------*/
#*     touchall ...                                                    */
#*---------------------------------------------------------------------*/
touchall:
	@ touch *.scm c-file.c
	@ echo "touch done..."
	@ echo "-------------------------------"

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
.PHONY: lintclean clean cleanall distclean

lintclean:
	@- $(RM) -f $(LN_OBJECTS)
	@- $(RM) -f all.lint

distclean: lintclean
	@- $(RM) -f -r objs_c
	@- $(RM) -f -r objs_jvm
	@- $(RM) -f -r objs_dotnet
	@- $(RM) -f recette
	@- $(RM) -f recette.static
	@- $(RM) -f recette.exe
	@- $(RM) -f recette-jvm
	@- $(RM) -f recette-jvm.bat
	@- $(RM) -f recette-jvm-jar
	@- $(RM) -f recette-jvm-jar.jar
	@- $(RM) -f recette-dotnet
	@- $(RM) -f recette-dotnet.bat
	@- $(RM) -f recette-dotnet.exe
	@- $(RM) -f recette.log
	@- $(RM) -f misc/binary.BIN
	@- $(RM) -f gc.log
	@- $(RM) -f *.tree
	@- $(RM) -f *.ast
	@- $(RM) -f *.class
	@- $(RM) -f *.jas
	@- $(RM) -f *.obj
	@- $(RM) -f *.escm
	@- $(RM) -f .afile-c .afile-jvm .afile-dotnet
	@- $(RM) -f .etags
	@- $(RM) -f Manifest*
	@- $(RM) -f dummydir
	@ find . \( -name '*[~%]'                   \
                       -o -name '.??*[~%]'          \
                       -o -name '#*#'               \
                       -o -name '?*#'               \
                       -o -name '*.BAK'             \
                       -o -name \*core \)           \
                     -type f -exec $(RM) {} \;   
	@ echo "Clean up done..."
	@ echo "-------------------------------"

clean: distclean
	@- $(RM) -f .jfile-jvm .jfile-dotnet

cleanall: clean

#*---------------------------------------------------------------------*/
#*    lint                                                             */
#*---------------------------------------------------------------------*/
lint: all.lint
	@ echo "lint done..."
	@ echo "-------------------------------"

all.lint: $(LN_OBJECTS)
	@- $(RM) -f all.lint
	@- touch all.lint
	@ ( for p in *.ln;                 \
            do echo "   " $$p >> all.lint; \
            cat $$p >> all.lint;           \
            done )

#*---------------------------------------------------------------------*/
#*    .etags                                                           */
#*---------------------------------------------------------------------*/
.etags:
	$(BTAGS) $(JVM_OBJECTS:%.class=%.scm) $(C_OBJECTS:%.$(C_OBJ_EXTENSION)=%.scm) -o .etags

#*---------------------------------------------------------------------*/
#*    .jfile-jvm                                                       */
#*---------------------------------------------------------------------*/
.jfile-jvm:
	$(JFILE) $(JVM_OBJECTS:%.class=%.scm) -o .jfile-jvm

#*---------------------------------------------------------------------*/
#*    .jfile-dotnet                                                    */
#*---------------------------------------------------------------------*/
.jfile-dotnet:
	$(JFILE) $(DOTNET_OBJECTS:%.obj=%.scm) -o .jfile-dotnet

#*---------------------------------------------------------------------*/
#*    .afile-c                                                         */
#*---------------------------------------------------------------------*/
.afile-c:

=== runtime/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/runtime/Makefile                     */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Tue Mar 21 08:14:18 1995                          */
#*    Last change :  Sat Nov 12 14:28:57 2005 (serrano)                */
#*    Copyright   :  1995-2005 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The (gnu) makefile to build the Bigloo's library.                */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Default configuration                                            */
#*---------------------------------------------------------------------*/
include ../Makefile.config
include ../Makefile.misc

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# The Bigloo used to bootstrap the library and to produce the heap file
BIGLOO		= $(BOOTBINDIR)/bigloo
EFLAGS		=
# the shell to be used
SHELL           = /bin/sh
# configure
CONFIGURE	= $(BOOTDIR)/configure
# The heap file
HEAPC_FILE	= bigloo.heap
HEAPJVM_FILE	= bigloo.jheap
# Default object file locations
OBJDIR_SYS	= obj_s
OBJDIR_USR	= obj_s
# This two variables control how we are booting (from Scheme or C)
SCMOBJSUFFIX	= %.o
COBJSUFFIX	= 
# Default class file locations
CLASSDIR_SYS	= class_s
CLASSDIR_USR	= class_s
# Default class file locations
DOTNETDIR_SYS	= dotnet_s
DOTNETDIR_USR	= dotnet_s
# The class suffix
SCMCLASSSUFFIX	= %.class
# The dotnet suffix
SCMDOTNETSUFFIX = %.obj
# The module association file
AFILE		= .afile
AFILE_EXE	= $(BOOTBINDIR)/afile
# The package association file
JFILE		= .jfile
PBASE		= bigloo.runtime
JFILE_EXE	= $(BOOTBINDIR)/jfile
# The qualifier of the build library
LIBQ		= 
# IF_XXX tools
IF_MACH_SRC	= $(BOOTDIR)/tools/if_mach.c
IF_MACH_EXE	= $(BOOTBINDIR)/if_mach

#*---------------------------------------------------------------------*/
#*    Compilation flags                                                */
#*---------------------------------------------------------------------*/
#*--- General flags ---------------------------------------------------*/
# The Bigloo compilation option used the produce an heap file
BHEAPFLAGS	= -unsafe -q -mkheap -mklib -s -no-hello
#*--- Bigloo, common --------------------------------------------------*/
BCOMMONFLAGS	= -lib-dir $(BOOTLIBDIR) -cg
#*--- Bigloo, safe ----------------------------------------------------*/
BSAFEFLAGS	= $(BCOMMONFLAGS) \
                  -O3 -mklib -cc $(CC) -fsharing \
                  -q -rm -unsafev -eval '(set! *indent* 4)' \
                  -copt $(CPICFLAGS)
CSAFEFLAGS	= -I$(BOOTLIBDIR) $(CFLAGS) $(CPICFLAGS)
#*--- Bigloo JVM flags ------------------------------------------------*/
BGLJFLAGS	= -gjvm -jfile $(JFILE)
BJSAFEFLAGS	= -jvm-purify
#*--- Bigloo .NET flags -----------------------------------------------*/
BDOTNETFLAGS	= -dotnet-mono-workaround -dotnet-pnet-workaround
BDOTNETSFLAGS	= -dotnet-managed
#*--- Bigloo, safe, debug ---------------------------------------------*/
BGSAFEFLAGS	= $(BSAFEFLAGS) -g
#*--- Bigloo, unsafe, optimize ----------------------------------------*/
BUNSAFEFLAGS	= $(BCOMMONFLAGS) \
                  -O4 -mklib -cc $(CC) -fsharing -q -no-hello \
                  -copt $(CPICFLAGS) -unsafe
CUNSAFEFLAGS	= -I$(BOOTLIBDIR) $(CFLAGS) $(CPICFLAGS)
#*--- Bigloo, unsafe, profiled ----------------------------------------*/
BUNSAFEPFLAGS	= $(BCOMMONFLAGS) \
                  -O4 -mklib -unsafe -cc $(CC) -fsharing -q -no-hello \
                  -p -copt $(CPICFLAGS)
CUNSAFEPFLAGS	= -I$(BOOTLIBDIR) $(CFLAGS_P) $(CPICFLAGS) -DPROFILE
#*--- Bigloo, safe, debug, heap ---------------------------------------*/
BSAFEDBGFLAGS	= $(BSAFEFLAGS) -gheap -copt $(CPICFLAGS)
#*--- Bigloo, unsafe, heap --------------------------------------------*/
BUNSAFEDBGFLAGS	= $(BUNSAFEFLAGS) -gheap -copt $(CPICFLAGS)
CDBGFLAGS	= -I$(BOOTLIBDIR) $(CPICFLAGS) $(CUNSAFEFLAGS) $(BACKPTRFLAGS) -DBIGLOO_TRACE
#*--- GC compilation flags --------------------------------------------*/
#  Any change to these flags must be reported on the bdb/blib/Makefile */
GCOFLAGS	= -I$(BOOTLIBDIR) $(CFLAGS)
GCPFLAGS	= -I$(BOOTLIBDIR) $(CFLAGS_P) -DGATHERSTATS -DPROFILE
GCDBGFLAGS	= $(GCOFLAGS) $(BACKPTRFLAGS)

#*---------------------------------------------------------------------*/
#*    The assembler objects.                                           */
#*---------------------------------------------------------------------*/
_OBJ_MLIB	= mach_dep 

OBJ_MLIB	= $(_OBJ_MLIB:%=Mlib/%.o)                  
O_OBJ_MLIB      = $(OBJ_MLIB:%=$(O)/%)

#*---------------------------------------------------------------------*/
#*    C objects                                                        */
#*---------------------------------------------------------------------*/
CLIB		= cinit-obj cmain cerror cports cstring csymbol cvector \
                  cwriter capply cstruct csystem ccontrol ceval chash \
                  ctrace callcc cbinary cforeign cdsssl \
                  cucs2 cunicode cprocess csocket crgc ccustom cdlopen \
                  cdate csleep cthread cmmap

C_CLIB		= $(CLIB:%=Clib/%.c)

#*---------------------------------------------------------------------*/
#*    Java objects                                                     */
#*---------------------------------------------------------------------*/
JLIB		= foreign buffer configure stackwriter\
                  bbool output_string_port \
		  bchar input_console_port pair \
		  bexception input_file_port \
                  procedure \
		  bint input_port real \
		  bllong belong input_string_port input_pipe_port rest \
		  key struct \
		  callcc keyword symbol \
		  cobj cell magic \
		  cnst nil \
		  constant numeral \
		  custom obj unspecified \
		  eof object \
		  exit optional \
		  extended_pair output_port binary_port \
		  socket client_socket server_socket input_socket_port \
                  process flusher stack_trace dlopen \
                  bucs2 ucs2string bgldynamic date os \
                  input_procedure_port mutex condvar mmap

JLIB_SRC	= $(JLIB:%=%.java)
JAVA_JLIB	= $(JLIB:%=Jlib/%.java)

#*---------------------------------------------------------------------*/
#*    C# objects                                                       */
#*---------------------------------------------------------------------*/
CSLIB		= foreign buffer configure stackwriter\
		  bbool output_string_port \
		  bchar input_console_port pair \
		  bexception input_file_port \
                  procedure \
		  bint input_port real \
		  bllong belong input_string_port input_pipe_port rest \
		  key struct \
		  callcc keyword symbol \
		  cobj cell magic \
		  cnst nil \
		  constant numeral \
		  custom obj unspecified \
		  eof object \
		  exit optional \
		  extended_pair output_port binary_port \
		  socket client_socket server_socket input_socket_port \
		  process flusher stack_trace dlopen \
		  bucs2 ucs2string bgldynamic date \
		  output_stream_port output_socket_port os \
		  input_procedure_port mutex condvar mmap callback

CS_CSLIB	= $(CSLIB:%=CSlib/%.cs)

#*---------------------------------------------------------------------*/
#*    Scheme IEEE objects                                              */
#*---------------------------------------------------------------------*/
IEEE  		= boolean equiv pairlist char string control number \
                  fixnum flonum port vector symbol input output \
                  control5 

SCM_IEEE	= $(IEEE:%=Ieee/%.scm)
C_SCM_IEEE	= $(IEEE:%=Ieee/%.c)

#*---------------------------------------------------------------------*/
#*    Scheme R5rs objects                                              */
#*---------------------------------------------------------------------*/
R5RS  		= syntax hygiene

SCM_R5RS	= $(R5RS:%=R5rs/%.scm)
C_SCM_R5RS	= $(R5RS:%=R5rs/%.c)

#*---------------------------------------------------------------------*/
#*    Scheme extended objects                                          */
#*---------------------------------------------------------------------*/
LLIB		= bexit type bigloo error struct os hash \
                  tvector bit binary intext foreign dsssl ucs2 \
                  unicode process socket custom object pregexp date \
                  param thread trace base64 md5 bconfigure mmap

SCM_LLIB	= $(LLIB:%=Llib/%.scm)
C_SCM_LLIB	= $(LLIB:%=Llib/%.c)

#*---------------------------------------------------------------------*/
#*    The interpreter objects                                          */
#*---------------------------------------------------------------------*/
EVAL		= eval expand expanders expdlet expdbool expddefine \
                  expdcase expddo expdtry expdstruct evmeaning everror \
                  evcompile evenv progn macro expdquote evprimop \
                  expdsrfi0 expdrecord expdargs expdtrace library

SCM_EVAL	= $(EVAL:%=Eval/%.scm)
C_SCM_EVAL	= $(EVAL:%=Eval/%.c)

#*---------------------------------------------------------------------*/
#*    The Pattern matching compiler objects                            */
#*---------------------------------------------------------------------*/
MATCH		= compiler descr mexpand normalize s2cfun

SCM_MATCH	= $(MATCH:%=Match/%.scm)
C_SCM_MATCH	= $(MATCH:%=Match/%.c)

#*---------------------------------------------------------------------*/
#*    The Regular grammar generator objects                            */
#*---------------------------------------------------------------------*/
RGC		= rgccompile rgcdfa rgcrules rgctree rgcconfig \
                  rgcexpand rgcset rgcposix rgc

SCM_RGC		= $(RGC:%=Rgc/%.scm)
C_SCM_RGC	= $(RGC:%=Rgc/%.c)

#*---------------------------------------------------------------------*/
#*    The Pretty-printer objects                                       */
#*---------------------------------------------------------------------*/
PP		= pp circle

SCM_PP		= $(PP:%=Pp/%.scm)
C_SCM_PP	= $(PP:%=Pp/%.c)

#*---------------------------------------------------------------------*/
#*    The reader                                                       */
#*---------------------------------------------------------------------*/
READ		= reader

SCM_READ	= $(READ:%=Read/%.scm)
C_SCM_READ	= $(READ:%=Read/%.c)

#*---------------------------------------------------------------------*/
#*    The Lalr compiler objects                                        */
#*---------------------------------------------------------------------*/
LALR		= driver gen global lalr rewrite util

SCM_LALR	= $(LALR:%=Lalr/%.scm)
C_SCM_LALR	= $(LALR:%=Lalr/%.c)

#*---------------------------------------------------------------------*/
#*    All source files                                                 */
#*---------------------------------------------------------------------*/
SCM_USR_SRC	= $(SCM_IEEE) $(SCM_LLIB) $(SCM_R5RS)
SCM_SYS_SRC	= $(SCM_READ) $(SCM_RGC) $(SCM_PP) \
                  $(SCM_EVAL) $(SCM_MATCH) $(SCM_LALR)

#*---------------------------------------------------------------------*/
#*    Src files                                                        */
#*---------------------------------------------------------------------*/
SRC_FILES	= $(SCM_USR_SRC) $(SCM_SYS_SRC) \
                  $(C_CLIB) \
                  $(JAVA_JLIB:%/configure.java=) \
                  $(CS_CSLIB:%/configure.cs=) \
                  Mlib/mach_dep.c \
                  Mlib/sparc_sunos4_mach_dep.s Mlib/sparc_sunos5_mach_dep.s \
                  Ilib/realcallback.il

=== api/fthread/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/api/fthread/Makefile                 */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Oct  3 05:37:54 2001                          */
#*    Last change :  Fri Nov 11 15:15:22 2005 (serrano)                */
#*    Copyright   :  2001-05 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    This Makefile *requires* GNU-Make.                               */
#*    -------------------------------------------------------------    */
#*    The Makefile for fthread                                         */
#*=====================================================================*/
include ../../Makefile.config

#*---------------------------------------------------------------------*/
#*    Directories where to find the files composing a revision         */
#*---------------------------------------------------------------------*/
POPDIR		= src examples recette

POPULATION	= Makefile README

#*---------------------------------------------------------------------*/
#*    all                                                              */
#*---------------------------------------------------------------------*/
all: boot-c boot-jvm boot-dotnet
boot: boot-c boot-jvm boot-dotnet

boot-c:
	@ if [ "$(PTHREADLIBS)" = "no" ]; then \
          echo "[0m[1;32m>>> No native support[0m"; \
        else \
	  if [ "$(CGCTHREADFLAGS)" = "no" ]; then \
            echo "[0m[1;32m>>> No native support[0m"; \
          else \
	    echo "[0m[1;32m>>> C[0m"; \
	    (cd src && $(MAKE) c) || exit 1; \
            if [ "$(GCCUSTOM)" = "yes" ]; then \
              (cd ../../runtime && $(MAKE) gc_fth) \
            fi \
          fi \
        fi

boot-jvm:
	@ echo "[0m[1;31m>>> JVM[0m";
	(cd src && $(MAKE) jvm)

boot-dotnet:
	@ echo "[0m[1;31m>>> .NET[0m";
	(cd src && $(MAKE) dotnet)

#*---------------------------------------------------------------------*/
#*    ude                                                              */
#*---------------------------------------------------------------------*/
ude:
	(cd src && $(MAKE) ude)

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*    -------------------------------------------------------------    */
#*    This entry is used by the bigloo/Makefile (the main Bigloo       */
#*    makefile) to get the list of file that populate a revision.      */
#*---------------------------------------------------------------------*/
.PHONY: pop
pop:
	@ echo $(POPULATION:%=fthread/%)
	@ for d in $(POPDIR); do \
            (cd $$d && $(MAKE) -s pop) \
          done;

#*---------------------------------------------------------------------*/
#*    Clean                                                            */
#*---------------------------------------------------------------------*/
clean:
	(cd src && $(MAKE) clean)
	(cd recette && $(MAKE) clean)
	(cd examples && $(MAKE) clean)

distclean: clean
	(cd src && $(MAKE) distclean)
	(cd recette && $(MAKE) distclean)
	(cd examples && $(MAKE) distclean)

cleanall: distclean
	(cd src && $(MAKE) cleanall)
	$(RM) -f lib/*fth* >/dev/null 2>&1
	$(RM) -f *~ >/dev/null 2>&1

#*---------------------------------------------------------------------*/
#*    Installation                                                     */
#*---------------------------------------------------------------------*/
.PHONY: install install-c install-jvm uninstall

include ../../Makefile.misc

install: install-init install-c install-jvm install-dotnet

install-init:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/fthread.init $(DESTDIR)$(FILDIR)/fthread.init && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/fthread.init; \
        fi

install-c:
	if [ "$(PTHREADLIBS)" != "no" ]; then \
	  if [ "$(CGCTHREADFLAGS)" != "no" ]; then \
	    (cd ../../runtime && $(MAKE) install-thread); \
	    if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	      cp $(BOOTLIBDIR)/fthread.heap $(DESTDIR)$(FILDIR)/fthread.heap && \
	      chmod $(BMASK) $(DESTDIR)$(FILDIR)/fthread.heap; \
            fi; \
	    $(MAKE) install-lib LIB=libbigloofth_s-$(RELEASE); \
	    $(MAKE) install-shared-lib LIB=libbigloofth_e-$(RELEASE); \
	    $(MAKE) install-lnlib LIB=libbigloofth_s-$(RELEASE) LN=libbigloofth_u-$(RELEASE); \
         fi; \
       fi

install-jvm:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/fthread.jheap $(DESTDIR)$(FILDIR)/fthread.jheap && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/fthread.jheap && \
	  cp $(BOOTLIBDIR)/bigloofth_s-$(RELEASE).zip $(DESTDIR)$(FILDIR)/bigloofth_s-$(RELEASE).zip && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloofth_s-$(RELEASE).zip && \
	  (cd $(DESTDIR)$(FILDIR) && \
           $(RM) -f bigloofth_u-$(RELEASE).zip && \
           ln bigloofth_s-$(RELEASE).zip bigloofth_u-$(RELEASE).zip); \
	  (cd $(DESTDIR)$(FILDIR) && \
           $(RM) -f bigloofth_e-$(RELEASE).zip && \
           ln bigloofth_s-$(RELEASE).zip bigloofth_e-$(RELEASE).zip); \
        fi

install-dotnet:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/fthread.jheap $(DESTDIR)$(FILDIR)/fthread.jheap && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/fthread.jheap && \
	  cp $(BOOTLIBDIR)/bigloofth_s-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloofth_s-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloofth_s-$(RELEASE).dll && \
	  cp $(BOOTLIBDIR)/bigloofth_u-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloofth_u-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloofth_u-$(RELEASE).dll ; \
	  cp $(BOOTLIBDIR)/bigloofth_e-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloofth_e-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloofth_e-$(RELEASE).dll ; \
        fi

uninstall:
	-$(RM) -f $(DESTDIR)$(FILDIR)/fthread.init
	-$(RM) -f $(DESTDIR)$(FILDIR)/fthread.heap
	-$(MAKE) uninstall-lib LIB=libbigloofth_s-$(RELEASE)
	-$(MAKE) uninstall-lib LIB=libbigloofth_u-$(RELEASE)
	-$(MAKE) uninstall-lib LIB=libbigloofth_e-$(RELEASE)
	-$(RM) -f $(DESTDIR)$(FILDIR)/fthread.jheap
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloofth_s-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloofth_e-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloofth_u-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloofth_s-$(RELEASE).dll
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloofth_u-$(RELEASE).dll
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloofth_e-$(RELEASE).dll

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:
	(cd src && $(MAKE) ude)

=== api/pthread/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/api/pthread/Makefile                 */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Oct  3 05:37:54 2001                          */
#*    Last change :  Fri Nov 11 15:15:05 2005 (serrano)                */
#*    Copyright   :  2001-05 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    This Makefile *requires* GNU-Make.                               */
#*    -------------------------------------------------------------    */
#*    The Makefile for pthread                                         */
#*=====================================================================*/
include ../../Makefile.config

#*---------------------------------------------------------------------*/
#*    Directories where to find the files composing a revision         */
#*---------------------------------------------------------------------*/
POPDIR		= src recette recette2

POPULATION	= Makefile README

#*---------------------------------------------------------------------*/
#*    all                                                              */
#*---------------------------------------------------------------------*/
all: boot-c boot-jvm boot-dotnet
boot: boot-c boot-jvm boot-dotnet

boot-c:
	@ if [ "$(PTHREADLIBS)" = "no" ]; then \
          echo "[0m[1;32m>>> No native support[0m"; \
        else \
	  if [ "$(CGCTHREADFLAGS)" = "no" ]; then \
            echo "[0m[1;32m>>> No native support[0m"; \
          else \
	    echo "[0m[1;32m>>> C[0m"; \
	    (cd src && $(MAKE) c) || exit 1; \
            if [ "$(GCCUSTOM)" = "yes" ]; then \
              (cd ../../runtime && $(MAKE) gc_fth) \
            fi \
          fi \
        fi

boot-jvm:
	@ echo "[0m[1;31m>>> JVM[0m";
	(cd src && $(MAKE) jvm)

boot-dotnet:
	@ echo "[0m[1;31m>>> .NET[0m";
	(cd src && $(MAKE) dotnet)

#*---------------------------------------------------------------------*/
#*    ude                                                              */
#*---------------------------------------------------------------------*/
ude:
	(cd src && $(MAKE) ude)

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*    -------------------------------------------------------------    */
#*    This entry is used by the bigloo/Makefile (the main Bigloo       */
#*    makefile) to get the list of file that populate a revision.      */
#*---------------------------------------------------------------------*/
.PHONY: pop
pop:
	@ echo $(POPULATION:%=pthread/%)
	@ for d in $(POPDIR); do \
            (cd $$d && $(MAKE) -s pop) \
          done;

#*---------------------------------------------------------------------*/
#*    Clean                                                            */
#*---------------------------------------------------------------------*/
clean:
	(cd src && $(MAKE) clean)
	(cd recette && $(MAKE) clean)

distclean: clean
	(cd src && $(MAKE) distclean)
	(cd recette && $(MAKE) distclean)

cleanall: distclean
	(cd src && $(MAKE) cleanall)
	$(RM) -f lib/*pth* >/dev/null 2>&1
	$(RM) -f *~ >/dev/null 2>&1

#*---------------------------------------------------------------------*/
#*    Installation                                                     */
#*---------------------------------------------------------------------*/
.PHONY: install install-c install-jvm uninstall

include ../../Makefile.misc

install: install-init install-c install-jvm install-dotnet

install-init:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/pthread.init $(DESTDIR)$(FILDIR)/pthread.init && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/pthread.init; \
        fi

install-c:
	if [ "$(PTHREADLIBS)" != "no" ]; then \
	  if [ "$(CGCTHREADFLAGS)" != "no" ]; then \
	    (cd ../../runtime && $(MAKE) install-thread); \
	    if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	      cp $(BOOTLIBDIR)/pthread.heap $(DESTDIR)$(FILDIR)/pthread.heap && \
	      chmod $(BMASK) $(DESTDIR)$(FILDIR)/pthread.heap; \
            fi; \
	    $(MAKE) install-lib LIB=libbigloopth_s-$(RELEASE); \
	    $(MAKE) install-shared-lib LIB=libbigloopth_e-$(RELEASE); \
	    $(MAKE) install-lnlib LIB=libbigloopth_s-$(RELEASE) LN=libbigloopth_u-$(RELEASE); \
          fi; \
        fi

install-jvm:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/pthread.jheap $(DESTDIR)$(FILDIR)/pthread.jheap && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/pthread.jheap && \
	  cp $(BOOTLIBDIR)/bigloopth_s-$(RELEASE).zip $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).zip && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).zip && \
	  (cd $(DESTDIR)$(FILDIR) && \
           $(RM) -f bigloopth_u-$(RELEASE).zip && \
           ln bigloopth_s-$(RELEASE).zip bigloopth_u-$(RELEASE).zip); \
	  (cd $(DESTDIR)$(FILDIR) && \
           $(RM) -f bigloopth_e-$(RELEASE).zip && \
           ln bigloopth_s-$(RELEASE).zip bigloopth_e-$(RELEASE).zip); \
        fi

install-dotnet:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/pthread.jheap $(DESTDIR)$(FILDIR)/pthread.jheap && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/pthread.jheap && \
	  cp $(BOOTLIBDIR)/bigloopth_s-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).dll && \
	  cp $(BOOTLIBDIR)/bigloopth_u-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloopth_u-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloopth_u-$(RELEASE).dll ; \
	  cp $(BOOTLIBDIR)/bigloopth_e-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloopth_e-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloopth_e-$(RELEASE).dll ; \
        fi

uninstall:
	-$(RM) -f $(DESTDIR)$(FILDIR)/pthread.init
	-$(RM) -f $(DESTDIR)$(FILDIR)/pthread.heap
	-$(MAKE) uninstall-lib LIB=libbigloopth_s-$(RELEASE)
	-$(MAKE) uninstall-lib LIB=libbigloopth_u-$(RELEASE)
	-$(MAKE) uninstall-lib LIB=libbigloopth_e-$(RELEASE)
	-$(RM) -f $(DESTDIR)$(FILDIR)/pthread.jheap
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_u-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_e-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).dll
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_u-$(RELEASE).dll
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_e-$(RELEASE).dll

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:
	(cd src && $(MAKE) ude)

=== bdb/bdb/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bdb/bdb/Makefile                     */
#*    -------------------------------------------------------------    */
#*    Author      :  serrano                                           */
#*    Creation    :  Wed Jul 28 06:59:47 1999                          */
#*    Last change :  Mon Oct 31 15:23:15 2005 (serrano)                */
#*    -------------------------------------------------------------    */
#*    Automatically generated file:                                    */
#*       bmake                                                         */
#*          -fapplication                                              */
#*          -main                                                      */
#*          Init/main.scm                                              */
#*          -o                                                         */
#*          Makefile                                                   */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../../Makefile.config

#*---------------------------------------------------------------------*/
#*    Target and Project                                               */
#*---------------------------------------------------------------------*/
PROJECT		= src
VERSION		= 0
TARGET_DIR      = $(BOOTBINDIR)
TARGET_NAME     = bdb

#*---------------------------------------------------------------------*/
#*    The project mode (either `devel' or `final').                    */
#*---------------------------------------------------------------------*/
MODE		= final

#*---------------------------------------------------------------------*/
#*    Compilers, Flags and Tools ...                                   */
#*---------------------------------------------------------------------*/
# The Bigloo compiler
BIGLOO          = $(BOOTBINDIR)/bigloo
BFLAGS_COMMON   = -afile $(AFILE) -no-hello -L $(BOOTLIBDIR)
BFLAGS_G        = $(BFLAGS_COMMON) -g2
BFLAGS_O        = $(BFLAGS_COMMON) -O5 #-O5 -unsafe
BFLAGS_P        = $(BFLAGS_COMMON) -O5 -unsafe -static-bigloo -p
BFLAGS_P2       = $(BFLAGS_COMMON) -O5 -unsafe -static-bigloo -p2
BFLAGS          = $(BFLAGS_G)
LNFLAGS_G       = 
LNFLAGS_O       = -s
LNFLAGS_P       = 
LNFLAGS         = $(LNFLAGS_G)
# The mco builder (this could be Bigloo itself or a speciliazed tools)
MCO_EXE		= ../../bin/mco
MCOFLAGS	= -I . -s # when using Bigloo, add the -mco flags here
# The interface builder
BUILDER		= buildoo
BLNFLAGS	= -no-event-loop --generate
# The C compiler
TK_LIB		= $$HOME/prgm/project/bglk/tk
CFLAGS_O	= $(CFLAGS)
# Which shell to use
SHELL           = /bin/sh
# Revision system
PRCS            = prcs
COMPRESS        = gzip
# Afile
AFILE_EXE       = afile
AFILE		= .afile
# Tags
TAGS_EXE	= btags
TAGS		= .etags
# Depend
DEPEND_EXE	= bdepend
BMAKE_EXE	= bmake
# Profiling
BPROF_EXE	= bprof
PROF		= PROF
PROFILE_ARGS	= 

#*---------------------------------------------------------------------*/
#*    Suffixes ...						       */
#*---------------------------------------------------------------------*/
.SUFFIXES:

#*---------------------------------------------------------------------*/
#*    Automatic rules ...					       */
#*    -------------------------------------------------------------    */
#*    One may add some automatic rules. Before explicit rules, we      */
#*    were making use of:                                              */
#*    -------------------------------------------------------------    */
#* %.o: %.scm                                                          */
#* 	@ $(BIGLOO) $(BFLAGS) -c $*.scm -o $*.o                        */
#*                                                                     */
#* %_p.o: %.scm                                                        */
#* 	@ $(BIGLOO) $(BFLAGS_P) -c $*.scm -o $*_p.o                    */
#*                                                                     */
#* %.mco:                                                              */
#* 	@ $(BIGLOO) $(BFLAGS) -s -mco $*.scm -o $*.mco                 */
#*                                                                     */
#* %.o: %.c                                                            */
#* 	@ echo $*.c:; $(CC) $(CFLAGS) -c $*.c -o $*.o                  */
#*                                                                     */
#* %_p.o: %.c                                                          */
#* 	@ echo $*.c:; $(CC) $(CFLAGS_P) -c $*.c -o $*.o; mv $*.o $@    */
#*                                                                     */
#* %_p.mco:                                                            */
#* 	@ $(BIGLOO) $(BFLAGS) -s -mco $*.scm -o $*_p.mco               */
#*                                                                     */
#* %.scm: %.bld                                                        */
#* 	@ $(BUILDER) $(BLNFLAGS) $*.bld -o $*.scm                      */
#*---------------------------------------------------------------------*/

#*---------------------------------------------------------------------*/
#*    Objects and sources ...					       */
#*---------------------------------------------------------------------*/
OBJECTS = Command/command.mco Command/explore.mco Init/setrc.mco        \
      Command/parse.mco Gdb/gread.mco Gdb/tools.mco Engine/engine.mco   \
      Command/set.mco Bee/etags.mco Tools/error.mco                     \
      Command/backtrace.mco Patient/value.mco Gdb/annotate.mco          \
      Gdb/autoconf.mco Engine/param.mco Tools/version.mco               \
      Command/display.mco Engine/repl.mco Gdb/ginvoke.mco               \
      Patient/server.mco Command/run.mco Tools/speek.mco                \
      Command/all-cmd.mco Tools/date.mco Init/parse-args.mco            \
      Tools/io.mco Command/help.mco Command/print.mco                   \
      Patient/mangling.mco Command/whatis.mco Tools/tools.mco           \
      Patient/pinvoke.mco Command/file.mco Command/break.mco            \
      Command/mangle.mco Gdb/proc.mco Command/expr.mco Command/info.mco \
      Bee/binvoke.mco Command/quit.mco Init/main.mco Command/command.o  \
      Command/explore.o Init/setrc.o Command/parse.o Gdb/gread.o        \
      Gdb/tools.o Engine/engine.o Command/set.o Bee/etags.o             \
      Tools/error.o Command/backtrace.o Patient/value.o Gdb/annotate.o  \
      Gdb/autoconf.o Engine/param.o Tools/version.o Command/display.o   \
      Engine/repl.o Gdb/ginvoke.o Patient/server.o Command/run.o        \
      Tools/speek.o Command/all-cmd.o Tools/date.o Init/parse-args.o    \
      Tools/io.o Command/help.o Command/print.o Patient/mangling.o      \
      Command/whatis.o Tools/tools.o Patient/pinvoke.o Command/file.o   \
      Command/break.o Command/mangle.o Gdb/proc.o Command/expr.o        \
      Command/info.o Bee/binvoke.o Command/quit.o Init/main.o           \
      Tools/tty.o 
GUI_OBJECTS = 
OBJECTS_P = Command/command_p.mco Command/explore_p.mco                 \
      Init/setrc_p.mco Command/parse_p.mco Gdb/gread_p.mco              \
      Gdb/tools_p.mco Engine/engine_p.mco Command/set_p.mco             \
      Bee/etags_p.mco Tools/error_p.mco Command/backtrace_p.mco         \
      Patient/value_p.mco Gdb/annotate_p.mco Gdb/autoconf_p.mco         \
      Engine/param_p.mco Tools/version_p.mco Command/display_p.mco      \
      Engine/repl_p.mco Gdb/ginvoke_p.mco Patient/server_p.mco          \
      Command/run_p.mco Tools/speek_p.mco Command/all-cmd_p.mco         \
      Tools/date_p.mco Init/parse-args_p.mco Tools/io_p.mco             \
      Command/help_p.mco Command/print_p.mco Patient/mangling_p.mco     \
      Command/whatis_p.mco Tools/tools_p.mco Patient/pinvoke_p.mco      \
      Command/file_p.mco Command/break_p.mco Command/mangle_p.mco       \
      Gdb/proc_p.mco Command/expr_p.mco Command/info_p.mco              \
      Bee/binvoke_p.mco Command/quit_p.mco Init/main_p.mco              \
      Command/command_p.o Command/explore_p.o Init/setrc_p.o            \
      Command/parse_p.o Gdb/gread_p.o Gdb/tools_p.o Engine/engine_p.o   \
      Command/set_p.o Bee/etags_p.o Tools/error_p.o                     \
      Command/backtrace_p.o Patient/value_p.o Gdb/annotate_p.o          \
      Gdb/autoconf_p.o Engine/param_p.o Tools/version_p.o               \
      Command/display_p.o Engine/repl_p.o Gdb/ginvoke_p.o               \
      Patient/server_p.o Command/run_p.o Tools/speek_p.o                \
      Command/all-cmd_p.o Tools/date_p.o Init/parse-args_p.o            \
      Tools/io_p.o Command/help_p.o Command/print_p.o                   \
      Patient/mangling_p.o Command/whatis_p.o Tools/tools_p.o           \
      Patient/pinvoke_p.o Command/file_p.o Command/break_p.o            \
      Command/mangle_p.o Gdb/proc_p.o Command/expr_p.o Command/info_p.o \
      Bee/binvoke_p.o Command/quit_p.o Init/main_p.o Tools/tty_p.o 
SOURCES = Tools/tty.c Command/command.scm Command/explore.scm           \
      Init/setrc.scm Command/parse.scm Gdb/gread.scm Gdb/tools.scm      \
      Engine/engine.scm Command/set.scm Bee/etags.scm Tools/error.scm   \
      Command/backtrace.scm Patient/value.scm Gdb/annotate.scm          \
      Gdb/autoconf.scm Engine/param.scm Tools/version.scm               \
      Command/display.scm Engine/repl.scm Gdb/ginvoke.scm               \
      Patient/server.scm Command/run.scm Tools/speek.scm                \
      Command/all-cmd.scm Tools/date.scm Init/parse-args.scm            \
      Tools/io.scm Command/help.scm Command/print.scm                   \
      Patient/mangling.scm Command/whatis.scm Tools/tools.scm           \
      Patient/pinvoke.scm Command/file.scm Command/break.scm            \
      Command/mangle.scm Gdb/proc.scm Command/expr.scm Command/info.scm \
      Bee/binvoke.scm Command/quit.scm Init/main.scm 
SOURCES_C = Command/command.c Command/explore.c Init/setrc.c            \
      Command/parse.c Gdb/gread.c Gdb/tools.c Engine/engine.c           \
      Command/set.c Bee/etags.c Tools/error.c Command/backtrace.c       \
      Patient/value.c Gdb/annotate.c Gdb/autoconf.c Engine/param.c      \
      Tools/version.c Command/display.c Engine/repl.c Gdb/ginvoke.c     \
      Patient/server.c Command/run.c Tools/speek.c Command/all-cmd.c    \
      Tools/date.c Init/parse-args.c Tools/io.c Command/help.c          \
      Command/print.c Patient/mangling.c Command/whatis.c Tools/tools.c \
      Patient/pinvoke.c Command/file.c Command/break.c Command/mangle.c \
      Gdb/proc.c Command/expr.c Command/info.c Bee/binvoke.c            \
      Command/quit.c Init/main.c 
POPULATION = $(SOURCES) Makefile Engine/hooks.sch

#*---------------------------------------------------------------------*/
#*    trashcan ...						       */
#*---------------------------------------------------------------------*/
All: all
all: mode
mode:
	$(MAKE) $(MODE)

main: $(TARGET_DIR)/$(TARGET_NAME)
$(TARGET_DIR)/$(TARGET_NAME): $(GUI_OBJECTS) $(OBJECTS)
	@ echo "Linking..."
	@ $(BIGLOO) $(BFLAGS) $(LNFLAGS) $(OBJECTS) -o $(TARGET_DIR)/$(TARGET_NAME)
	@ echo "$(TARGET_DIR)/$(TARGET_NAME) done."
	@ echo "-------------------------------"

devel: $(TARGET_DIR)
	@ $(MAKE) -f Makefile main BFLAGS="$(BFLAGS_G)" LNFLAGS="$(LNFLAGS_G)" CFLAGS="$(CFLAGS_G)"

final: $(TARGET_DIR)
	@ $(MAKE) -f Makefile main BFLAGS="$(BFLAGS_O)" LNFLAGS="$(LNFLAGS_O)" CFLAGS="$(CFLAGS_O)"

profile_comp: $(TARGET_DIR) main_p
main_p: forceafile forcetags $(TARGET_DIR)/$(TARGET_NAME)_p
$(TARGET_DIR)/$(TARGET_NAME)_p: $(OBJECTS_P)
	@ echo "Linking..."

=== bdb/blib/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bdb/blib/Makefile                    */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Apr  1 18:45:46 1998                          */
#*    Last change :  Thu Sep 15 18:41:40 2005 (serrano)                */
#*    -------------------------------------------------------------    */
#*    The makefile to build the bdb library.                           */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Standard Bdb configuration                                       */
#*---------------------------------------------------------------------*/
include ../../Makefile.config
include ../../Makefile.misc

#*---------------------------------------------------------------------*/
#*    Compilers, Tools and Destinations                                */
#*---------------------------------------------------------------------*/
# the library name
TARGETNAME	= bdb
LIBNAME		= bigloobdb
# Directories
LIB         	= $(BOOTLIBDIR)
# The heap file
HEAP_FILE	= $(LIB)/$(TARGETNAME).heap
HEAPJVM_FILE	= $(LIB)/$(TARGETNAME).jheap
# Where to store the library class files
PBASE		= bigloo.bdb
CLASS_DIR	= objs/class/bigloo/bdb
# The Bigloo compiler
BIGLOO		= $(BOOTBINDIR)/bigloo
AFILE		= $(BOOTBINDIR)/afile
JFILE		= $(BOOTBINDIR)/jfile
DEPEND		= $(BOOTBINDIR)/bdepend
BTAGS		= $(BOOTBINDIR)/btags
# Flags to build a heap
BHEAPFLAGS	= -unsafe -q -mkaddheap -mkaddlib -L $(LIB) -heap-library bdb
# C flags
CFLAGS		= -I$(BGL_INC_DIR) -I. -I$(BOOTLIBDIR) $(CPICFLAGS) $(GCINCLUDE)
# Bigloo flags
BDBFLAGS	= $(BFLAGS) -farithmetic -init-lib

#*---------------------------------------------------------------------*/
#*    Scheme extended objects                                          */
#*---------------------------------------------------------------------*/
_BGL_OBJECTS	= bdb env

_C_OBJECTS	= stat table
_JAVA_CLASSES	= 

_OBJECTS	= $(_C_OBJECTS) $(_BGL_OBJECTS)
OBJECTS		= $(_OBJECTS:%=objs/%.o)

BGL_CLASSES	= $(_BGL_OBJECTS:%=$(CLASS_DIR)/%.class)
JAVA_CLASSES	= $(_JAVA_CLASSES:%=$(CLASS_DIR)/%.class)
JAVA_CLASSES_SRC= $(_JAVA_CLASSES:%=$(CLASS_DIR)/%.java)
CLASSES		= $(_BGL_CLASSES) $(JAVA_CLASSES)

_BGL_SOURCES	= $(_BGL_OBJECTS:%=%.scm) 
_C_SOURCES	= $(_C_OBJECTS:%=%.c) 
_JAVA_SOURCES	= $(_JAVA_CLASSES:%=%.java) 

SOURCES		= $(_BGL_SOURCES) $(_C_SOURCES) $(_JAVA_SOURCES)
INCLUDES	= color.h

#*---------------------------------------------------------------------*/
#*    Sources                                                          */
#*---------------------------------------------------------------------*/
POPULATION	= $(SOURCES) $(INCLUDES) Makefile make-lib.scm

#*---------------------------------------------------------------------*/
#*    all & jvm                                                        */
#*---------------------------------------------------------------------*/
all: lib-c heap-c

#*---------------------------------------------------------------------*/
#*    Suffixes                                                         */
#*---------------------------------------------------------------------*/
.SUFFIXES:
.SUFFIXES: .scm .class .java .o

#*---------------------------------------------------------------------*/
#*    The implicit rules                                               */
#*---------------------------------------------------------------------*/
objs/%.o: %.scm
	$(BIGLOO) -no-hello $(BDBFLAGS) -copt $(CPICFLAGS) $< -o $@ -c

objs/%.o: %.c
	$(CC) $(CFLAGS) $(CPICFLAGS) -I. -I $(LIB) $< -o $@ -c

$(CLASS_DIR)/%.class: %.scm
	$(BIGLOO) -no-hello -jvm $(BJVMFLAGS) $(BDBFLAGS) -c $< -o $@

$(CLASS_DIR)/%.java: %.java
	ln -f $< $@

#*---------------------------------------------------------------------*/
#*    The heap construction                                            */
#*---------------------------------------------------------------------*/
.PHONY: heap heap-c heap-jvm

heap: heap-c heap-jvm
heap-c: $(HEAP_FILE)
heap-jvm: $(HEAPJVM_FILE)

$(HEAP_FILE): .afile make-lib.scm
	@ $(RM) -f $(HEAP_FILE)
	@ $(BIGLOO) $(BHEAPFLAGS) make-lib.scm -addheap $(HEAP_FILE)
	@ echo "$(HEAP_FILE) Done..."
	@ echo "-------------------------------"

$(HEAPJVM_FILE): .jfile .afile make-lib.scm
	@ $(RM) -f $(HEAPJVM_FILE)
	@ $(BIGLOO) -jvm $(BHEAPFLAGS) make-lib.scm -addheap $(HEAPJVM_FILE)
	@ echo "$(HEAPJVM_FILE) Done..."
	@ echo "-------------------------------"

#*---------------------------------------------------------------------*/
#*    lib                                                              */
#*---------------------------------------------------------------------*/
.PHONY: lib lib-c lib-jvm

lib: lib-c lib-jvm

#*--- lib-c -----------------------------------------------------------*/
lib-c: $(TAGS) .afile $(CLASS_DIR) \
        lib.$(SHAREDSUFFIX) \
        lib.a

lib.$(SHAREDSUFFIX): $(LIB)/lib$(LIBNAME)_s-$(RELEASE).$(SHAREDSUFFIX)
lib.a: $(LIB)/lib$(LIBNAME)_s-$(RELEASE).a


$(LIB)/lib$(LIBNAME)_s-$(RELEASE).$(SHAREDSUFFIX): .afile $(OBJECTS)
	@ $(MAKE) shared-lib \
             LIBDEST=$@ \
             SONAME=lib$(LIBNAME)_s-$(RELEASE).$(SHAREDSUFFIX) \
             CLOSELIBS="-lbigloo_s-$(RELEASE)"

$(LIB)/lib$(LIBNAME)_s-$(RELEASE).a: .afile $(OBJECTS)
	@ $(RM) -f $(LIB)/lib$(LIBNAME)_s-$(RELEASE).a
	@ $(AR) $(ARFLAGS) $(LIB)/lib$(LIBNAME)_s-$(RELEASE).a $(OBJECTS)
	@ $(RANLIB) $(LIB)/lib$(LIBNAME)_s-$(RELEASE).a
	@ echo "$(LIB)/lib$(LIBNAME)_s-$(RELEASE).a Done..."
	@ echo "-------------------------------"

#*--- lib-jvm ---------------------------------------------------------*/
lib-jvm: $(TAGS) $(CLASS_DIR) lib.zip

$(CLASS_DIR): 
	mkdir -p $(CLASS_DIR)

lib.zip: .afile .jfile $(BGL_CLASSES) $(JAVA_CLASSES_SRC) dojavac
	@ $(RM) -f $(LIB)/$(TARGETNAME)_s.zip
	@ (cd objs/class && \
	  $(ZIP) -q $(ZFLAGS) \
                 $(LIB)/$(TARGETNAME)_s.zip \
                 $(CLASS_DIR:objs/class/%=%)/*.class)
	@ echo "$(LIB)/lib$(TARGETNAME)_s.zip done..."
	@ echo "-------------------------------"

dojavac: 
	if [ "$(JAVA_CLASSES_SRC) " != " " ]; then \
	   echo $(JAVA_CLASSES_SRC); \
	   (CLASSPATH=$(LIB)/bigloo.zip:$$CLASSPATH; export CLASSPATH; \
            cd objs/class/bigloo && \
            $(JAVAC) $(CYGWINJVMPATH) $(JAVA_CLASSES_SRC:objs/class/bigloo/%=%)) \
        fi

#*---------------------------------------------------------------------*/
#*    ude                                                              */
#*---------------------------------------------------------------------*/
.PHONY: ude
ude:
	@ $(MAKE) -f Makefile .afile .etags .jfile

.afile: $(SOURCES)
	@ $(AFILE) -o .afile $(_BGL_SOURCES) 

.jfile: $(SOURCES)
	@ $(JFILE) -o .jfile -pbase $(PBASE) $(SOURCES) 

.etags: $(SOURCES)
	@ $(BTAGS) -o .etags $(_BGL_SOURCES)

#*---------------------------------------------------------------------*/
#*    stdclean                                                         */
#*---------------------------------------------------------------------*/
stdclean:
	$(RM) -f $(OBJECTS) $(_BGL_OBJECTS:%=%.c)
	$(RM) -f $(LIB)/lib$(LIBNAME)_s.$(SHAREDSUFFIX)
	$(RM) -f $(LIB)/$(TARGETNAME)_s.zip
	$(RM) -f $(LIB)/$(TARGETNAME).jheap $(LIB)/$(TARGETNAME).heap
	$(RM) -f $(LIB)/$(TARGETNAME).init
	$(RM) -rf $(CLASS_DIR)
	$(RM) -f *~
	$(RM) -f *.mco
	$(RM) -f *.ast

#*---------------------------------------------------------------------*/
#*    udeclean                                                         */
#*---------------------------------------------------------------------*/
udeclean:
	$(RM) -f .afile .etags .jfile

#*---------------------------------------------------------------------*/
#*    pop ...                                                          */
#*---------------------------------------------------------------------*/
pop:
	@ echo $(POPULATION)

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
clean: stdclean
	$(RM) -rf objs

cleanall: stdclean udeclean

#*---------------------------------------------------------------------*/
#*    Dependences                                                      */
#*---------------------------------------------------------------------*/

=== debian/changelog ===
bigloo (2.7a-1) unstable; urgency=low

  * Final upstream release.
  * Reactivated ia64 build, since #336918 is believed to be fixed.

 -- Yann Dirson <dirson@debian.org>  Mon, 21 Nov 2005 20:51:46 +0100

bigloo (2.6f+2.7a-051116-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Wed, 16 Nov 2005 21:34:48 +0100

bigloo (2.6f+2.7a-051105-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Sun,  6 Nov 2005 16:01:43 +0100

bigloo (2.6f+2.7a-051027-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Fri, 28 Oct 2005 18:53:20 +0200

bigloo (2.6f+2.7a-051026-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Wed, 26 Oct 2005 19:23:58 +0200

bigloo (2.6f+2.7a-051022-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Sat, 22 Oct 2005 14:42:39 +0200

bigloo (2.6f+2.7a-051017-1) unstable; urgency=low

  * New upstream beta release.
  * Run the tests after build to get an idea of the results on all
    platforms (only the jvm mmap test fails on i386).  
  * Added note in README.Debian about the missing mmap feature in the jvm.

 -- Yann Dirson <dirson@debian.org>  Mon, 17 Oct 2005 20:36:12 +0200

bigloo (2.6f+2.7a-051013-2) unstable; urgency=low

  * Switch to free-java-sdk, instead of requesting individual packages
    (this means we will use jikes instead of kaffe), both in build-deps
    and backend-jvm deps.

 -- Yann Dirson <dirson@debian.org>  Sat, 15 Oct 2005 14:53:47 +0200

bigloo (2.6f+2.7a-051013-1) unstable; urgency=low

  * New upstream beta release.
  * Use conditionnal dh_install to install jigloo, instead of conditionnal
    cp and subsequent unconditionnal dh_movefiles, which caused errors.
  * Removed mips from the list of archs supporting jvm backend, since
    there is no gcj there, and the future of kaffe support on that arch is
    uncertain anyway.
  * Added missing .gz suffix to info index filenames in doc-base files (linda).

 -- Yann Dirson <dirson@debian.org>  Sat, 15 Oct 2005 00:03:05 +0200

bigloo (2.6f+2.7a-051012-1) unstable; urgency=low

  * New upstream beta release.
  * Do not try to put jigloo in the package on archs where we do not build
    it.

 -- Yann Dirson <dirson@debian.org>  Wed, 12 Oct 2005 23:00:58 +0200

bigloo (2.6f+2.7a-051005-3) unstable; urgency=low

  * Only attempt to build jigloo on jvm-enabled platforms.

 -- Yann Dirson <dirson@debian.org>  Sun,  9 Oct 2005 15:55:21 +0200

bigloo (2.6f+2.7a-051005-2) unstable; urgency=low

  * Disabled jvm backend on mipsel, where no kaffe/gcj is available for
    now.
  * Tuned build-deps to avoid java-related stuff on platforms where we do
    not build the jvm backend.
  * Put bigloo-doc in section doc to match the override.

 -- Yann Dirson <dirson@debian.org>  Sat,  8 Oct 2005 17:46:40 +0200

bigloo (2.6f+2.7a-051005-1) unstable; urgency=low

  * New upstream beta release, fixing an issue with gcc 4.x.  Dropped the
    dependencies on gcc-3.4.

 -- Yann Dirson <dirson@debian.org>  Wed,  5 Oct 2005 21:22:02 +0200

bigloo (2.6f+2.7a-050920-1) unstable; urgency=low

  * New upstream beta release.
  * Added alpha to the arch list for jvm backend, now that kaffe/#328328
    is fixed.
  * Removed build-dep on fastjar, which was not used anyway, now that
    kaffe uses fastjar itself.

 -- Yann Dirson <dirson@debian.org>  Sat, 24 Sep 2005 14:23:41 +0200

bigloo (2.6f+2.7a-050916-2) unstable; urgency=low

  * Be sure not to attempt to build the deb of the jvm backend where
    disabled.

 -- Yann Dirson <dirson@debian.org>  Sat, 17 Sep 2005 10:05:22 +0200

bigloo (2.6f+2.7a-050916-1) unstable; urgency=low

  * New upstream beta release.
  * Desactivate build of jvm backend for platforms with known problems:
    sparc (sablevm #328311), ia64 (sablevm), alpha (kaffe/jar #328328),
    m68k (already on build-ignore list).  
  * Pass --jvm flag to configure based on debian/control Architecture
    field.

 -- Yann Dirson <dirson@debian.org>  Fri, 16 Sep 2005 20:34:26 +0200

bigloo (2.6f+2.7a-050818-5) unstable; urgency=low

  * Have bigloo-backend-native depend on gcc-3.4 instead of just gcc
    (Closes: #327318).

 -- Yann Dirson <dirson@debian.org>  Sat, 10 Sep 2005 13:44:19 +0200

bigloo (2.6f+2.7a-050818-4) unstable; urgency=low

  * Added fastjar to build-depends.

 -- Yann Dirson <dirson@debian.org>  Mon,  5 Sep 2005 19:18:11 +0200

bigloo (2.6f+2.7a-050818-3) unstable; urgency=low

  * Added zip to build-depends (Closes: #319297).

 -- Yann Dirson <dirson@debian.org>  Sun,  4 Sep 2005 15:26:20 +0200

bigloo (2.6f+2.7a-050818-2) unstable; urgency=low

  * Restored the build-deps for previously-disabled jvm backend.
  * Build jigloo before bigloo, so that if gcj fails the buildd time is
    not wasted uselessly.

 -- Yann Dirson <dirson@debian.org>  Sat, 20 Aug 2005 23:57:41 +0200

bigloo (2.6f+2.7a-050818-1) unstable; urgency=low

  * New upstream beta release.
  * Reactivated the build of the jvm backend.

 -- Yann Dirson <dirson@debian.org>  Sat, 20 Aug 2005 18:10:35 +0200

bigloo (2.6f+2.7a-050721-1) unstable; urgency=low

  * New upstream beta release.
  * Restored build-dep on gcj to get jigloo built.

 -- Yann Dirson <dirson@debian.org>  Thu, 21 Jul 2005 21:32:07 +0200

bigloo (2.6f+2.7a-050720-1) unstable; urgency=low

  * New upstream beta release.
  * Deactivated build of java backend, until kaffe gets updated - we need
    to tackle other problems first.  The jvm package is still built but
    empty, with a note in the description.

 -- Yann Dirson <dirson@debian.org>  Wed, 20 Jul 2005 21:41:31 +0200

bigloo (2.6f+2.7a-050708-4) unstable; urgency=low

  * Use kaffe as javac and sablevm as java, as those look like the
    prefered ones.  Adapted build-deps accordingly.

 -- Yann Dirson <dirson@debian.org>  Mon, 18 Jul 2005 01:52:50 +0200

bigloo (2.6f+2.7a-050708-3) unstable; urgency=low



=== debian/control ===
Source: bigloo
Section: interpreters
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>= 4.1.1), dh-buildinfo, texinfo, dbs, gcj [!sparc !mipsel !mips], libgcj6-dev [!sparc !mipsel !mips], free-java-sdk [!sparc !mipsel !mips], zip [!sparc !mipsel !mips]
Build-Depends-Indep: skribe
Standards-Version: 3.6.2

Package: bigloo
Architecture: any
Depends: ${shlibs:Depends}, bigloo-backend-native | bigloo-backend, ${bigloo:Runtime}
Recommends: bigloo-backend-native
Suggests: bigloo-devtools, bigloo-ude
Description: A practical Scheme compiler
 Bigloo is a Scheme system which includes a compiler generating 
 C, java, or .NET code, and an interpreter.
 .
 Bigloo conforms to IEEE Scheme and is mostly conformant to Revised^5
 Report on the Algorithmic Language Scheme with many extensions:
  - SRFI 0, 2, 6, 8, 9, 18, 22, 28, and support for using the
  reference implementations of other SRFIs.
  - Rgc, a lex facility.
  - Match, a pattern-matching compiler.
  - Foreign languages interface.
  - Module language.
  - Extension package system.
  - An LALR facility.
  - An Object system.
  - Some DSSSL support features.
  - Unicode characters and strings.
  - Process, Pipe and Socket support.

Package: libbigloo2.7a
Architecture: any
Section: libs
Depends: ${shlibs:Depends}
Description: Run-time libraries for Bigloo-generated programs
 Provides the shared run-time libraries that enable programs
 compiled with this version of Bigloo to be run, without needing
 to have the full compiler installed.

Package: bigloo-backend-native
Architecture: any
Provides: bigloo-backend
Depends: bigloo (= ${Source-Version}), gcc, libc6-dev
Conflicts: bigloo (<= 2.6f+2.7a-050708-1)
Replaces: bigloo (<= 2.6f+2.7a-050708-1)
Description: Bigloo support to build native executables
 Provides the support files to compile scheme programs into native
 executables using bigloo.

Package: bigloo-backend-jvm
Architecture: i386 powerpc s390 amd64 arm hppa alpha ia64
X-BrokenJVM-Architectures: sparc (sablevm #328311) ia64 (sablevm #336918, maybe fixed now) m68k (does not build anyway) mipsel (no gcj, no kaffe) mips (no gcj)
Provides: bigloo-backend
Depends: bigloo (= ${Source-Version}), free-java-sdk
Description: Bigloo support to build JVM bytecode
 Provides the support files to compile scheme programs into JVM
 bytecode using bigloo.

Package: bigloo-devtools
Architecture: any
Depends: bigloo (>= 2.4b-3), ${shlibs:Depends}
Suggests: bigloo-ude
Description: Tools to help developping Bigloo programs
 A couple of development tools are provided for Bigloo.  Since they
 are not necessary for building a package, but are "only" useful for
 people intending to write, debug, or modify bigloo programs, they are
 shipped in a separate package.
 .
 These tools include:
  * bdb: the Bigloo debugger
  * cigloo: a declaration builder for interfacing with C code

Package: bigloo-ude
Architecture: all
Depends: bigloo (>= 2.4b-3), xemacs21 | emacs21, make
Suggests: prcs, texinfo, bigloo-devtools, binutils
Description: Bigloo Unified Development Environment for Emacs
 A development environment for the Bigloo scheme compiler, targeted to
 XEmacs and GNU Emacs21.

Package: bigloo-doc
Architecture: all
Section: doc
Suggests: bigloo
Replaces: bigloo (<= 2.5a+really2.5b-beta-2002-07-26-3), bigloo-devtools (<= 2.5b-1)
Description: Documentation for the Bigloo scheme compiler
 This is the documentation for Bigloo and its development environment,
 in HTML and info formats.

Package: bigloo-examples
Architecture: all
Recommends: bigloo
Description: Examples for the Bigloo scheme compiler
 This is the set of examples from the Bigloo distribution.

=== debian/rules ===
#!/usr/bin/make -f

## can't call $(shell ) here as the file is generated during the build
#BIGLOO_RELEASE=$$(grep ^RELEASE= ${BUILD_TREE}/Makefile.config | cut -d= -f2)
BIGLOO_RELEASE=$(shell /bin/ls bigloo*.tar.gz | sed 's/bigloo\([^-]*\)\(-.*\)*.tar.gz/\1/')

TAR_DIR = bigloo${BIGLOO_RELEASE}

PKG_VERSION=$(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2)

JVM_ARCHS=$(shell grep -E '^(Package|Architecture)' debian/control | grep -A1 bigloo-backend-jvm | grep ^Architecture|cut -d: -f2 | tr , ' ')

include /usr/share/dbs/dbs-build.mk

ifeq (,$(DEB_BUILD_GNU_TYPE))
 include /usr/share/dbs/dpkg-arch.mk
endif

EXTRA_CONFIG_FLAGS=
NO_PACKAGES=
CC=gcc

ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifeq (${ARCH},arm)
#CC=gcc-3.2
EXTRA_CONFIG_FLAGS += --coflags=-O2 --cpicflags=-fPIC
else
#CC=gcc
endif

ifeq (,$(filter $(ARCH),$(JVM_ARCHS)))
EXTRA_CONFIG_FLAGS += --jvm=no
NO_PACKAGES += -Nbigloo-backend-jvm
GCJ=
else
EXTRA_CONFIG_FLAGS += --javaprefix=/usr/lib/fjsdk/bin
GCJ=gcj
endif

export DH_OPTIONS
export LC_ALL=C

ELISPDIR=/usr/share/emacs/site-lisp/bigloo-ude

$(STAMP_DIR)/configure: $(patched)
	dh_testdir
	cd ${BUILD_TREE} && env ./configure ${EXTRA_CONFIG_FLAGS} --prefix=/usr \
			--mandir=/usr/share/man/man1 \
			--infodir=/usr/share/info \
			--ld=${CC} --cc=${CC} \
			--bee=full \
			--customgc=yes \
			--dotnet=no # for now
	touch $(STAMP_DIR)/configure

# FIXME: build-indep will be restored as a dependency of build only when
# autobuilders call build-arch directly, or we get a build-dep loop with
# scribe.  It is listed as an install-indep target, so that should not
# cause any problem, appart from having docs build only at "binary" time.
build: build-arch # build-indep

build-arch: $(STAMP_DIR)/build-arch
$(STAMP_DIR)/build-arch: $(STAMP_DIR)/configure
	dh_testdir

ifneq ($(GCJ),)
	mkdir -p ${BUILD_TREE}/bin
	$(GCJ) --main=jigloo -o ${BUILD_TREE}/bin/jigloo ${BUILD_TREE}/jigloo/jigloo.java
endif

	env \
		LD_LIBRARY_PATH=$(CURDIR)/${BUILD_TREE}/lib/${BIGLOO_RELEASE}:${LD_LIBRARY_PATH} \
			$(MAKE) -C $(BUILD_TREE)
	env \
		BIGLOOLIB=$(CURDIR)/${BUILD_TREE}/lib/${BIGLOO_RELEASE} \
		LD_LIBRARY_PATH=$(CURDIR)/${BUILD_TREE}/lib/${BIGLOO_RELEASE}:${LD_LIBRARY_PATH} \
		PATH=$(CURDIR)/${BUILD_TREE}/bin:$$PATH \
			$(MAKE) -C $(BUILD_TREE) compile-bee

	# do not fail if the tests do not pass, since we know the jvm mmap test fails
	-$(MAKE) -C $(BUILD_TREE) test

	touch $(STAMP_DIR)/build-arch

build-indep: $(STAMP_DIR)/build-indep
$(STAMP_DIR)/build-indep: $(STAMP_DIR)/build-arch
	dh_testdir

	$(MAKE) -C $(BUILD_TREE)/manuals info info-bee # html

	touch $(STAMP_DIR)/build-indep

clean:
	dh_testdir
	dh_testroot
	rm -rf $(STAMP_DIR) $(SOURCE_DIR)
	perl $(SCRIPT_DIR)/dbs_split clean
	rm -f debian/shlibs.local
	dh_clean

install-indep: DH_OPTIONS=-i
install-indep: install-arch build-indep
	dh_testdir
	dh_testroot
	dh_clean -k

	mkdir -p debian/tmp/usr/share/info
	$(MAKE) -C $(BUILD_TREE) install-docs \
		DESTDIR=$(CURDIR)/debian/tmp \
		DOCDIR=$(CURDIR)/debian/tmp/usr/share/doc/bigloo-doc
	$(MAKE) -C $(BUILD_TREE)/manuals install-info-bee \
		DESTDIR=$(CURDIR)/debian/tmp
	cp $(BUILD_TREE)/manuals/bdb*html debian/tmp/usr/share/doc/bigloo-doc
	$(MAKE) -C $(BUILD_TREE)/manuals uninstall-man \
		DESTDIR=$(CURDIR)/debian/tmp
	rm -f debian/tmp/usr/share/info/dir

 # fixes
#	cd debian/tmp/usr/share/info && rm -f dir dir.old
	rm debian/tmp/usr/share/doc/bigloo-doc/r5rs*
	rm -f debian/tmp/usr/share/doc/bigloo-doc/*.sui

 # source for emacs environment
  # install source
	for f in `cd $(BUILD_TREE)/bmacs && find -name '*.el'`; do \
		mkdir -p debian/tmp${ELISPDIR}/`dirname $$f`; \
		cp $(BUILD_TREE)/bmacs/$$f debian/tmp${ELISPDIR}/$$f; \
	done
	cp -a $(BUILD_TREE)/bmacs/Makefile $(BUILD_TREE)/bmacs/etc debian/tmp${ELISPDIR}/
  # neutralize that rule to avoid refering to BOOTDIR at install-time
	perl -pi -e 's/^bmacs-config.el/xbmacs-config.el/' \
		debian/tmp${ELISPDIR}/Makefile

	dh_movefiles
	test -z "`find debian/tmp -not -type d | tee /dev/fd/2`"

  # create symlinks to easily locate the doc
	mkdir -p debian/bigloo-doc/usr/share/doc/bigloo
	ln -s ../bigloo-doc debian/bigloo-doc/usr/share/doc/bigloo/manuals
	mkdir -p debian/bigloo-doc/usr/share/doc/bigloo-devtools
	ln -s ../bigloo-doc debian/bigloo-doc/usr/share/doc/bigloo-devtools/manuals
	mkdir -p debian/bigloo-examples/usr/share/doc/bigloo
	ln -s ../bigloo-examples debian/bigloo-examples/usr/share/doc/bigloo/examples

install-arch: DH_OPTIONS=-a
install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	mkdir debian/tmp
	cd debian/tmp && mkdir -p usr/bin usr/lib usr/share/info

	$(MAKE) -C $(BUILD_TREE) install-progs install-bee DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C $(BUILD_TREE)/manuals install-man install-bee DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C $(BUILD_TREE)/manuals uninstall-info-bee DESTDIR=$(CURDIR)/debian/tmp

 # fixes
	rm -f debian/tmp/usr/bin/jas
	chmod 644 debian/tmp/usr/lib/bigloo/$(BIGLOO_RELEASE)/*
	find debian/tmp -name '*.css' | xargs chmod 644

	cd debian/tmp/usr/lib && \
	  for f in *.so ; do \
	    rm $$f && ln -s bigloo/$(BIGLOO_RELEASE)/$$f $$f ; \
	  done

 # create a symlink binary named "bigloo" - upstream makes a hardlink
	rm -f debian/tmp/usr/bin/bigloo
	cd debian/tmp/usr/bin && ln -s bigloo$(BIGLOO_RELEASE) bigloo

 # removes info files, they're for arch-indep
	rm -f debian/tmp/usr/info/bigloo.info*

	dh_movefiles

ifneq ($(GCJ),) 
 # java program built natively
	DH_OPTIONS= dh_install -pbigloo-devtools $(BUILD_TREE)/bin/jigloo usr/bin
endif

	test -z "`find debian/tmp ! -type d | tee /dev/fd/2`"

 # make an easy-to-locate symlink for use by the ude package
	 ln -s $(BIGLOO_RELEASE)/Makefile.config \
		debian/bigloo/usr/lib/bigloo/Makefile.config

	(cd debian/libbigloo${BIGLOO_RELEASE}/usr/lib/bigloo/$(BIGLOO_RELEASE) && \
	  for f in *-${BIGLOO_RELEASE}.so ; do \
		ln -s $$f $$(echo $$f | sed "s/-${BIGLOO_RELEASE}//") ; \
	  done )


binary-indep: DH_OPTIONS=-i
binary-indep: install-indep
	dh_testdir
	dh_testroot
	dh_installchangelogs $(BUILD_TREE)/ChangeLog
	dh_installdocs
	dh_buildinfo

	dh_installexamples
 # have Makefiles use the right location for Makefile.config
	find debian/bigloo-examples/usr/share/doc/bigloo-examples -name Makefile |\
	  xargs perl -pi -e 's,^include [./]*Makefile.config$$,/usr/lib/bigloo/Makefile.config,; s/BOOTBINDIR/BINDIR/g; s/BOOTLIBDIR/FILDIR/g;'
	cp -a $(BUILD_TREE)/bdl/example debian/bigloo-examples/usr/share/doc/bigloo-examples/examples/bdl
	cp -a $(BUILD_TREE)/api/fthread/examples debian/bigloo-examples/usr/share/doc/bigloo-examples/examples/fthread

#	dh_installdebconf	
	dh_installemacsen
	dh_installinfo
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-arch: DH_OPTIONS=-a $(NO_PACKAGES)
binary-arch: install-arch
	dh_testdir
	dh_testroot
	dh_installchangelogs $(BUILD_TREE)/ChangeLog
	dh_installdocs
	for i in jigloo srfi; do \
	  cp -p $(BUILD_TREE)/$$i/README debian/bigloo/usr/share/doc/bigloo/README.$$i; done
	for i in fthread pthread; do \
	  cp -p $(BUILD_TREE)/api/$$i/README debian/bigloo/usr/share/doc/bigloo/README.api-$$i; done
	dh_buildinfo
	dh_installmenu
#	dh_installdebconf	
	dh_strip
	dh_installinfo
	dh_link usr/share/man/man1/bigloo.1.gz \
		usr/share/man/man1/bigloo${BIGLOO_RELEASE}.1.gz

	dh_compress
	dh_fixperms
	dh_makeshlibs -V
	dh_installdeb

	rm -f debian/shlibs.local
	for lib in `cd $(BUILD_TREE)/lib/$(BIGLOO_RELEASE) && echo *.so`; do \
	  echo "$${lib%-${BIGLOO_RELEASE}.so} $(BIGLOO_RELEASE) libbigloo$(BIGLOO_RELEASE) (= $(PKG_VERSION))" \
		>> debian/shlibs.local; \
	done

	dh_shlibdeps -ldebian/libbigloo${BIGLOO_RELEASE}/usr/lib \
		-L libbigloo${BIGLOO_RELEASE}
	echo >>debian/bigloo.substvars "bigloo:Runtime=libbigloo${BIGLOO_RELEASE}"
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=2
opts=passive ftp://ftp-sop.inria.fr/mimosa/fp/Bigloo/bigloo([0-9].*).tar.gz
